import { defineComponent as ee, ref as y, computed as A, provide as oe, reactive as P, watch as D, onBeforeUpdate as ne, onMounted as le, nextTick as te, resolveComponent as ae, openBlock as V, createElementBlock as z, normalizeClass as re, Fragment as se, renderList as ce, createBlock as ue } from "vue";
import de from "./menu.js";
import F from "./store.js";
import ie from "./node.js";
import { CommonProps as fe, useCascaderConfig as me } from "./config.js";
import { sortByOriginalOrder as pe, checkNode as ve, getMenuIndex as K } from "./utils.js";
import { CASCADER_PANEL_INJECTION_KEY as he } from "./types.js";
import Ne from "../../../_virtual/plugin-vue_export-helper.js";
import { UPDATE_MODEL_EVENT as I, CHANGE_EVENT as H } from "../../../constants/event.js";
import { useNamespace as ge } from "../../../hooks/use-namespace/index.js";
import { isEmpty as U } from "../../../utils/types.js";
import { unique as G, castArray as J } from "../../../utils/arrays.js";
import { scrollIntoView as ke } from "../../../utils/dom/scroll.js";
import { EVENT_CODE as C } from "../../../constants/aria.js";
import { focusNode as $, getSibling as Ee } from "../../../utils/dom/aria.js";
import R from "../../../../../lodash-es/isEqual.js";
import ye from "../../../../../lodash-es/flattenDeep.js";
import Ce from "../../../../../lodash-es/cloneDeep.js";
import { isClient as be } from "../../../../../@vueuse/shared/index.js";
const _e = ee({
  name: "ElCascaderPanel",
  components: {
    ElCascaderMenu: de
  },
  props: {
    ...fe,
    border: {
      type: Boolean,
      default: !0
    },
    renderLabel: Function
  },
  emits: [I, H, "close", "expand-change"],
  setup(r, { emit: p, slots: L }) {
    let b = !1;
    const d = ge("cascader"), u = me(r);
    let s = null;
    const v = y(!0), i = y([]), g = y(null), N = y([]), k = y(null), h = y([]), Y = A(() => u.value.expandTrigger === "hover"), j = A(() => r.renderLabel || L.default), Q = () => {
      const { options: e } = r, o = u.value;
      b = !1, s = new F(e, o), N.value = [s.getNodes()], o.lazy && U(r.options) ? (v.value = !1, w(void 0, (n) => {
        n && (s = new F(n, o), N.value = [s.getNodes()]), v.value = !0, E(!1, !0);
      })) : E(!1, !0);
    }, w = (e, o) => {
      const n = u.value;
      e = e || new ie({}, n, void 0, !0), e.loading = !0;
      const l = (t) => {
        const a = e, f = a.root ? null : a;
        t && (s == null || s.appendNodes(t, f)), a.loading = !1, a.loaded = !0, a.childrenData = a.childrenData || [], o && o(t);
      };
      n.lazyLoad(e, l);
    }, S = (e, o) => {
      var n;
      const { level: l } = e, t = N.value.slice(0, l);
      let a;
      e.isLeaf ? a = e.pathNodes[l - 2] : (a = e, t.push(e.children)), ((n = k.value) == null ? void 0 : n.uid) !== (a == null ? void 0 : a.uid) && (k.value = e, N.value = t, !o && p("expand-change", (e == null ? void 0 : e.pathValues) || []));
    }, B = (e, o, n = !0) => {
      const { checkStrictly: l, multiple: t } = u.value, a = h.value[0];
      b = !0, !t && (a == null || a.doCheck(!1)), e.doCheck(o), x(), n && !t && !l && p("close"), !n && !t && !l && M(e);
    }, M = (e) => {
      e && (e = e.parent, M(e), e && S(e));
    }, T = (e) => s == null ? void 0 : s.getFlattedNodes(e), q = (e) => {
      var o;
      return (o = T(e)) == null ? void 0 : o.filter((n) => n.checked !== !1);
    }, W = () => {
      h.value.forEach((e) => e.doCheck(!1)), x(), N.value = N.value.slice(0, 1), k.value = null, p("expand-change", []);
    }, x = () => {
      var e;
      const { checkStrictly: o, multiple: n } = u.value, l = h.value, t = q(!o), a = pe(l, t), f = a.map((c) => c.valueByOption);
      h.value = a, g.value = n ? f : (e = f[0]) != null ? e : null;
    }, E = (e = !1, o = !1) => {
      const { modelValue: n } = r, { lazy: l, multiple: t, checkStrictly: a } = u.value, f = !a;
      if (!(!v.value || b || !o && R(n, g.value)))
        if (l && !e) {
          const _ = G(ye(J(n))).map((m) => s == null ? void 0 : s.getNodeByValue(m)).filter((m) => !!m && !m.loaded && !m.loading);
          _.length ? _.forEach((m) => {
            w(m, () => E(!1, o));
          }) : E(!0, o);
        } else {
          const c = t ? J(n) : [n], _ = G(c.map((m) => s == null ? void 0 : s.getNodeByValue(m, f)));
          X(_, o), g.value = Ce(n);
        }
    }, X = (e, o = !0) => {
      const { checkStrictly: n } = u.value, l = h.value, t = e.filter((c) => !!c && (n || c.isLeaf)), a = s == null ? void 0 : s.getSameNode(k.value), f = o && a || t[0];
      f ? f.pathNodes.forEach((c) => S(c, !0)) : k.value = null, l.forEach((c) => c.doCheck(!1)), r.props.multiple ? P(t).forEach((c) => c.doCheck(!0)) : t.forEach((c) => c.doCheck(!0)), h.value = t, te(O);
    }, O = () => {
      be && i.value.forEach((e) => {
        const o = e == null ? void 0 : e.$el;
        if (o) {
          const n = o.querySelector(`.${d.namespace.value}-scrollbar__wrap`), l = o.querySelector(`.${d.b("node")}.${d.is("active")}`) || o.querySelector(`.${d.b("node")}.in-active-path`);
          ke(n, l);
        }
      });
    }, Z = (e) => {
      const o = e.target, { code: n } = e;
      switch (n) {
        case C.up:
        case C.down: {
          e.preventDefault();
          const l = n === C.up ? -1 : 1;
          $(Ee(o, l, `.${d.b("node")}[tabindex="-1"]`));
          break;
        }
        case C.left: {
          e.preventDefault();
          const l = i.value[K(o) - 1], t = l == null ? void 0 : l.$el.querySelector(`.${d.b("node")}[aria-expanded="true"]`);
          $(t);
          break;
        }
        case C.right: {
          e.preventDefault();
          const l = i.value[K(o) + 1], t = l == null ? void 0 : l.$el.querySelector(`.${d.b("node")}[tabindex="-1"]`);
          $(t);
          break;
        }
        case C.enter:
          ve(o);
          break;
      }
    };
    return oe(he, P({
      config: u,
      expandingNode: k,
      checkedNodes: h,
      isHoverMenu: Y,
      initialLoaded: v,
      renderLabelFn: j,
      lazyLoad: w,
      expandNode: S,
      handleCheckChange: B
    })), D([u, () => r.options], Q, {
      deep: !0,
      immediate: !0
    }), D(() => r.modelValue, () => {
      b = !1, E();
    }, {
      deep: !0
    }), D(() => g.value, (e) => {
      R(e, r.modelValue) || (p(I, e), p(H, e));
    }), ne(() => i.value = []), le(() => !U(r.modelValue) && E()), {
      ns: d,
      menuList: i,
      menus: N,
      checkedNodes: h,
      handleKeyDown: Z,
      handleCheckChange: B,
      getFlattedNodes: T,
      getCheckedNodes: q,
      clearCheckedNodes: W,
      calculateCheckedValue: x,
      scrollToExpandingNode: O
    };
  }
});
function we(r, p, L, b, d, u) {
  const s = ae("el-cascader-menu");
  return V(), z("div", {
    class: re([r.ns.b("panel"), r.ns.is("bordered", r.border)]),
    onKeydown: p[0] || (p[0] = (...v) => r.handleKeyDown && r.handleKeyDown(...v))
  }, [
    (V(!0), z(se, null, ce(r.menus, (v, i) => (V(), ue(s, {
      key: i,
      ref_for: !0,
      ref: (g) => r.menuList[i] = g,
      index: i,
      nodes: [...v]
    }, null, 8, ["index", "nodes"]))), 128))
  ], 34);
}
var Ge = /* @__PURE__ */ Ne(_e, [["render", we], ["__file", "/home/runner/work/element-plus/element-plus/packages/components/cascader-panel/src/index.vue"]]);
export {
  Ge as default
};
