import { defineComponent as U, inject as j, computed as l, resolveComponent as s, openBlock as r, createElementBlock as P, normalizeClass as C, createCommentVNode as u, createBlock as m, withModifiers as V, withCtx as g, createVNode as b, Fragment as B, createElementVNode as z } from "vue";
import { ElCheckbox as F } from "../../checkbox/index.js";
import { ElRadio as O } from "../../radio/index.js";
import { ElIcon as q } from "../../icon/index.js";
import { Check as J, Loading as K, ArrowRight as T } from "../../../../../@element-plus/icons-vue/dist/index.js";
import Y from "./node-content.js";
import { CASCADER_PANEL_INJECTION_KEY as G } from "./types.js";
import Q from "../../../_virtual/plugin-vue_export-helper.js";
import { useNamespace as W } from "../../../hooks/use-namespace/index.js";
const X = U({
  name: "ElCascaderNode",
  components: {
    ElCheckbox: F,
    ElRadio: O,
    NodeContent: Y,
    ElIcon: q,
    Check: J,
    Loading: K,
    ArrowRight: T
  },
  props: {
    node: {
      type: Object,
      required: !0
    },
    menuId: String
  },
  emits: ["expand"],
  setup(e, { emit: o }) {
    const a = j(G), I = W("cascader-node"), h = l(() => a.isHoverMenu), E = l(() => a.config.multiple), i = l(() => a.config.checkStrictly), N = l(() => {
      var n;
      return (n = a.checkedNodes[0]) == null ? void 0 : n.uid;
    }), c = l(() => e.node.isDisabled), d = l(() => e.node.isLeaf), f = l(() => i.value && !d.value || !c.value), v = l(() => t(a.expandingNode)), y = l(() => i.value && a.checkedNodes.some(t)), t = (n) => {
      var p;
      const { level: M, uid: R } = e.node;
      return ((p = n == null ? void 0 : n.pathNodes[M - 1]) == null ? void 0 : p.uid) === R;
    }, k = () => {
      v.value || a.expandNode(e.node);
    }, S = (n) => {
      const { node: p } = e;
      n !== p.checked && a.handleCheckChange(p, n);
    }, H = () => {
      a.lazyLoad(e.node, () => {
        d.value || k();
      });
    }, A = (n) => {
      h.value && (w(), !d.value && o("expand", n));
    }, w = () => {
      const { node: n } = e;
      !f.value || n.loading || (n.loaded ? k() : H());
    }, $ = () => {
      h.value && !d.value || (d.value && !c.value && !i.value && !E.value ? L(!0) : w());
    }, D = (n) => {
      i.value ? (S(n), e.node.loaded && k()) : L(n);
    }, L = (n) => {
      e.node.loaded ? (S(n), !i.value && k()) : H();
    };
    return {
      panel: a,
      isHoverMenu: h,
      multiple: E,
      checkStrictly: i,
      checkedNodeId: N,
      isDisabled: c,
      isLeaf: d,
      expandable: f,
      inExpandingPath: v,
      inCheckedPath: y,
      ns: I,
      handleHoverExpand: A,
      handleExpand: w,
      handleClick: $,
      handleCheck: L,
      handleSelectCheck: D
    };
  }
}), Z = ["id", "aria-haspopup", "aria-owns", "aria-expanded", "tabindex"], _ = /* @__PURE__ */ z("span", null, null, -1);
function x(e, o, a, I, h, E) {
  const i = s("el-checkbox"), N = s("el-radio"), c = s("check"), d = s("el-icon"), f = s("node-content"), v = s("loading"), y = s("arrow-right");
  return r(), P("li", {
    id: `${e.menuId}-${e.node.uid}`,
    role: "menuitem",
    "aria-haspopup": !e.isLeaf,
    "aria-owns": e.isLeaf ? null : e.menuId,
    "aria-expanded": e.inExpandingPath,
    tabindex: e.expandable ? -1 : void 0,
    class: C([
      e.ns.b(),
      e.ns.is("selectable", e.checkStrictly),
      e.ns.is("active", e.node.checked),
      e.ns.is("disabled", !e.expandable),
      e.inExpandingPath && "in-active-path",
      e.inCheckedPath && "in-checked-path"
    ]),
    onMouseenter: o[2] || (o[2] = (...t) => e.handleHoverExpand && e.handleHoverExpand(...t)),
    onFocus: o[3] || (o[3] = (...t) => e.handleHoverExpand && e.handleHoverExpand(...t)),
    onClick: o[4] || (o[4] = (...t) => e.handleClick && e.handleClick(...t))
  }, [
    u(" prefix "),
    e.multiple ? (r(), m(i, {
      key: 0,
      "model-value": e.node.checked,
      indeterminate: e.node.indeterminate,
      disabled: e.isDisabled,
      onClick: o[0] || (o[0] = V(() => {
      }, ["stop"])),
      "onUpdate:modelValue": e.handleSelectCheck
    }, null, 8, ["model-value", "indeterminate", "disabled", "onUpdate:modelValue"])) : e.checkStrictly ? (r(), m(N, {
      key: 1,
      "model-value": e.checkedNodeId,
      label: e.node.uid,
      disabled: e.isDisabled,
      "onUpdate:modelValue": e.handleSelectCheck,
      onClick: o[1] || (o[1] = V(() => {
      }, ["stop"]))
    }, {
      default: g(() => [
        u(`
        Add an empty element to avoid render label,
        do not use empty fragment here for https://github.com/vuejs/vue-next/pull/2485
      `),
        _
      ]),
      _: 1
    }, 8, ["model-value", "label", "disabled", "onUpdate:modelValue"])) : e.isLeaf && e.node.checked ? (r(), m(d, {
      key: 2,
      class: C(e.ns.e("prefix"))
    }, {
      default: g(() => [
        b(c)
      ]),
      _: 1
    }, 8, ["class"])) : u("v-if", !0),
    u(" content "),
    b(f),
    u(" postfix "),
    e.isLeaf ? u("v-if", !0) : (r(), P(B, { key: 3 }, [
      e.node.loading ? (r(), m(d, {
        key: 0,
        class: C([e.ns.is("loading"), e.ns.e("postfix")])
      }, {
        default: g(() => [
          b(v)
        ]),
        _: 1
      }, 8, ["class"])) : (r(), m(d, {
        key: 1,
        class: C(["arrow-right", e.ns.e("postfix")])
      }, {
        default: g(() => [
          b(y)
        ]),
        _: 1
      }, 8, ["class"]))
    ], 64))
  ], 42, Z);
}
var re = /* @__PURE__ */ Q(X, [["render", x], ["__file", "/home/runner/work/element-plus/element-plus/packages/components/cascader-panel/src/node.vue"]]);
export {
  re as default
};
