import { defineComponent as z, ref as u, computed as Y, watch as q, nextTick as G, openBlock as f, createElementBlock as p, unref as h, normalizeClass as O, createElementVNode as b, Fragment as C, renderList as T, withKeys as I, withModifiers as R, toDisplayString as H } from "vue";
import _ from "../../../../../../dayjs/dayjs.min.js";
import { basicMonthTableProps as J } from "../props/basic-month-table.js";
import Q from "../../../../_virtual/plugin-vue_export-helper.js";
import { rangeArr as U } from "../../../time-picker/src/utils.js";
import { useNamespace as W } from "../../../../hooks/use-namespace/index.js";
import { useLocale as X } from "../../../../hooks/use-locale/index.js";
import { castArray as A } from "../../../../utils/arrays.js";
import { hasClass as Z } from "../../../../utils/dom/style.js";
const ee = ["aria-label"], te = ["aria-selected", "aria-label", "tabindex", "onKeydown"], ae = { class: "cell" }, ne = /* @__PURE__ */ z({
  __name: "basic-month-table",
  props: J,
  emits: ["changerange", "pick", "select"],
  setup(B, { expose: E, emit: d }) {
    const e = B, j = (a, n, t) => {
      const r = _().locale(t).startOf("month").month(n).year(a), o = r.daysInMonth();
      return U(o).map((s) => r.add(s, "day").toDate());
    }, K = W("month-table"), { t: D, lang: x } = X(), w = u(), y = u(), L = u(e.date.locale("en").localeData().monthsShort().map((a) => a.toLowerCase())), V = u([
      [],
      [],
      []
    ]), k = u(), S = u(), M = Y(() => {
      var a, n;
      const t = V.value, r = _().locale(x.value).startOf("month");
      for (let o = 0; o < 3; o++) {
        const s = t[o];
        for (let l = 0; l < 4; l++) {
          const c = s[l] || (s[l] = {
            row: o,
            column: l,
            type: "normal",
            inRange: !1,
            start: !1,
            end: !1,
            text: -1,
            disabled: !1
          });
          c.type = "normal";
          const N = o * 4 + l, i = e.date.startOf("year").month(N), m = e.rangeState.endDate || e.maxDate || e.rangeState.selecting && e.minDate || null;
          c.inRange = !!(e.minDate && i.isSameOrAfter(e.minDate, "month") && m && i.isSameOrBefore(m, "month")) || !!(e.minDate && i.isSameOrBefore(e.minDate, "month") && m && i.isSameOrAfter(m, "month")), (a = e.minDate) != null && a.isSameOrAfter(m) ? (c.start = !!(m && i.isSame(m, "month")), c.end = e.minDate && i.isSame(e.minDate, "month")) : (c.start = !!(e.minDate && i.isSame(e.minDate, "month")), c.end = !!(m && i.isSame(m, "month"))), r.isSame(i) && (c.type = "today"), c.text = N, c.disabled = ((n = e.disabledDate) == null ? void 0 : n.call(e, i.toDate())) || !1;
        }
      }
      return t;
    }), F = () => {
      var a;
      (a = y.value) == null || a.focus();
    }, P = (a) => {
      const n = {}, t = e.date.year(), r = /* @__PURE__ */ new Date(), o = a.text;
      return n.disabled = e.disabledDate ? j(t, o, x.value).every(e.disabledDate) : !1, n.current = A(e.parsedValue).findIndex((s) => _.isDayjs(s) && s.year() === t && s.month() === o) >= 0, n.today = r.getFullYear() === t && r.getMonth() === o, a.inRange && (n["in-range"] = !0, a.start && (n["start-date"] = !0), a.end && (n["end-date"] = !0)), n;
    }, v = (a) => {
      const n = e.date.year(), t = a.text;
      return A(e.date).findIndex((r) => r.year() === n && r.month() === t) >= 0;
    }, $ = (a) => {
      var n;
      if (!e.rangeState.selecting)
        return;
      let t = a.target;
      if (t.tagName === "A" && (t = (n = t.parentNode) == null ? void 0 : n.parentNode), t.tagName === "DIV" && (t = t.parentNode), t.tagName !== "TD")
        return;
      const r = t.parentNode.rowIndex, o = t.cellIndex;
      M.value[r][o].disabled || (r !== k.value || o !== S.value) && (k.value = r, S.value = o, d("changerange", {
        selecting: !0,
        endDate: e.date.startOf("year").month(r * 4 + o)
      }));
    }, g = (a) => {
      var n;
      const t = (n = a.target) == null ? void 0 : n.closest("td");
      if ((t == null ? void 0 : t.tagName) !== "TD" || Z(t, "disabled"))
        return;
      const r = t.cellIndex, s = t.parentNode.rowIndex * 4 + r, l = e.date.startOf("year").month(s);
      e.selectionMode === "range" ? e.rangeState.selecting ? (e.minDate && l >= e.minDate ? d("pick", { minDate: e.minDate, maxDate: l }) : d("pick", { minDate: l, maxDate: e.minDate }), d("select", !1)) : (d("pick", { minDate: l, maxDate: null }), d("select", !0)) : d("pick", s);
    };
    return q(() => e.date, async () => {
      var a, n;
      (a = w.value) != null && a.contains(document.activeElement) && (await G(), (n = y.value) == null || n.focus());
    }), E({
      focus: F
    }), (a, n) => (f(), p("table", {
      role: "grid",
      "aria-label": h(D)("el.datepicker.monthTablePrompt"),
      class: O(h(K).b()),
      onClick: g,
      onMousemove: $
    }, [
      b("tbody", {
        ref_key: "tbodyRef",
        ref: w
      }, [
        (f(!0), p(C, null, T(h(M), (t, r) => (f(), p("tr", { key: r }, [
          (f(!0), p(C, null, T(t, (o, s) => (f(), p("td", {
            key: s,
            ref_for: !0,
            ref: (l) => v(o) && (y.value = l),
            class: O(P(o)),
            "aria-selected": `${v(o)}`,
            "aria-label": h(D)(`el.datepicker.month${+o.text + 1}`),
            tabindex: v(o) ? 0 : -1,
            onKeydown: [
              I(R(g, ["prevent", "stop"]), ["space"]),
              I(R(g, ["prevent", "stop"]), ["enter"])
            ]
          }, [
            b("div", null, [
              b("span", ae, H(h(D)("el.datepicker.months." + L.value[o.text])), 1)
            ])
          ], 42, te))), 128))
        ]))), 128))
      ], 512)
    ], 42, ee));
  }
});
var pe = /* @__PURE__ */ Q(ne, [["__file", "/home/runner/work/element-plus/element-plus/packages/components/date-picker/src/date-picker-com/basic-month-table.vue"]]);
export {
  pe as default
};
