import { defineComponent as A, useSlots as V, computed as u, ref as m, provide as O, openBlock as C, createBlock as h, Teleport as U, createVNode as p, Transition as j, unref as e, withCtx as s, withDirectives as K, createElementVNode as G, normalizeClass as H, normalizeStyle as J, mergeProps as Q, createSlots as W, renderSlot as n, createCommentVNode as X, vShow as Y } from "vue";
import { ElOverlay as Z } from "../../overlay/index.js";
import _ from "./dialog-content2.js";
import { dialogInjectionKey as x } from "./constants.js";
import { dialogProps as ee, dialogEmits as oe } from "./dialog.js";
import { useDialog as le } from "./use-dialog.js";
import te from "../../../_virtual/plugin-vue_export-helper.js";
import { useDeprecated as k } from "../../../hooks/use-deprecated/index.js";
import { useNamespace as se } from "../../../hooks/use-namespace/index.js";
import { useSameTarget as re } from "../../../hooks/use-same-target/index.js";
import ae from "../../focus-trap/src/focus-trap.js";
const ne = ["aria-label", "aria-labelledby", "aria-describedby"], ie = A({
  name: "ElDialog",
  inheritAttrs: !1
}), de = /* @__PURE__ */ A({
  ...ie,
  props: ee,
  emits: oe,
  setup(R, { expose: w }) {
    const a = R, E = V();
    k({
      scope: "el-dialog",
      from: "the title slot",
      replacement: "the header slot",
      version: "3.0.0",
      ref: "https://element-plus.org/en-US/component/dialog.html#slots"
    }, u(() => !!E.title)), k({
      scope: "el-dialog",
      from: "custom-class",
      replacement: "class",
      version: "2.3.0",
      ref: "https://element-plus.org/en-US/component/dialog.html#attributes",
      type: "Attribute"
    }, u(() => !!a.customClass));
    const i = se("dialog"), f = m(), F = m(), c = m(), {
      visible: d,
      titleId: g,
      bodyId: v,
      style: S,
      overlayDialogStyle: T,
      rendered: y,
      zIndex: $,
      afterEnter: D,
      afterLeave: L,
      beforeLeave: M,
      handleClose: b,
      onModalClick: I,
      onOpenAutoFocus: z,
      onCloseAutoFocus: B,
      onCloseRequested: P,
      onFocusoutPrevented: N
    } = le(a, f);
    O(x, {
      dialogRef: f,
      headerRef: F,
      bodyId: v,
      ns: i,
      rendered: y,
      style: S
    });
    const l = re(I), q = u(() => a.draggable && !a.fullscreen);
    return w({
      visible: d,
      dialogContentRef: c
    }), (o, t) => (C(), h(U, {
      to: o.appendTo,
      disabled: o.appendTo !== "body" ? !1 : !o.appendToBody
    }, [
      p(j, {
        name: "dialog-fade",
        onAfterEnter: e(D),
        onAfterLeave: e(L),
        onBeforeLeave: e(M),
        persisted: ""
      }, {
        default: s(() => [
          K(p(e(Z), {
            "custom-mask-event": "",
            mask: o.modal,
            "overlay-class": o.modalClass,
            "z-index": e($)
          }, {
            default: s(() => [
              G("div", {
                role: "dialog",
                "aria-modal": "true",
                "aria-label": o.title || void 0,
                "aria-labelledby": o.title ? void 0 : e(g),
                "aria-describedby": e(v),
                class: H(`${e(i).namespace.value}-overlay-dialog`),
                style: J(e(T)),
                onClick: t[0] || (t[0] = (...r) => e(l).onClick && e(l).onClick(...r)),
                onMousedown: t[1] || (t[1] = (...r) => e(l).onMousedown && e(l).onMousedown(...r)),
                onMouseup: t[2] || (t[2] = (...r) => e(l).onMouseup && e(l).onMouseup(...r))
              }, [
                p(e(ae), {
                  loop: "",
                  trapped: e(d),
                  "focus-start-el": "container",
                  onFocusAfterTrapped: e(z),
                  onFocusAfterReleased: e(B),
                  onFocusoutPrevented: e(N),
                  onReleaseRequested: e(P)
                }, {
                  default: s(() => [
                    e(y) ? (C(), h(_, Q({
                      key: 0,
                      ref_key: "dialogContentRef",
                      ref: c
                    }, o.$attrs, {
                      "custom-class": o.customClass,
                      center: o.center,
                      "align-center": o.alignCenter,
                      "close-icon": o.closeIcon,
                      draggable: e(q),
                      fullscreen: o.fullscreen,
                      "show-close": o.showClose,
                      title: o.title,
                      "aria-level": o.headerAriaLevel,
                      onClose: e(b)
                    }), W({
                      header: s(() => [
                        o.$slots.title ? n(o.$slots, "title", { key: 1 }) : n(o.$slots, "header", {
                          key: 0,
                          close: e(b),
                          titleId: e(g),
                          titleClass: e(i).e("title")
                        })
                      ]),
                      default: s(() => [
                        n(o.$slots, "default")
                      ]),
                      _: 2
                    }, [
                      o.$slots.footer ? {
                        name: "footer",
                        fn: s(() => [
                          n(o.$slots, "footer")
                        ])
                      } : void 0
                    ]), 1040, ["custom-class", "center", "align-center", "close-icon", "draggable", "fullscreen", "show-close", "title", "aria-level", "onClose"])) : X("v-if", !0)
                  ]),
                  _: 3
                }, 8, ["trapped", "onFocusAfterTrapped", "onFocusAfterReleased", "onFocusoutPrevented", "onReleaseRequested"])
              ], 46, ne)
            ]),
            _: 3
          }, 8, ["mask", "overlay-class", "z-index"]), [
            [Y, e(d)]
          ])
        ]),
        _: 3
      }, 8, ["onAfterEnter", "onAfterLeave", "onBeforeLeave"])
    ], 8, ["to", "disabled"]));
  }
});
var ke = /* @__PURE__ */ te(de, [["__file", "/home/runner/work/element-plus/element-plus/packages/components/dialog/src/dialog.vue"]]);
export {
  ke as default
};
