import { buildProps as o, definePropType as e } from "../../../utils/vue/props/runtime.js";
import { useTooltipTriggerProps as r } from "../../tooltip/src/trigger.js";
import { useTooltipContentProps as p } from "../../tooltip/src/content.js";
import { iconPropType as n } from "../../../utils/vue/icon.js";
import { EVENT_CODE as t } from "../../../constants/aria.js";
import { createCollectionWithScope as i } from "../../collection/src/collection.js";
const E = o({
  trigger: r.trigger,
  effect: {
    ...p.effect,
    default: "light"
  },
  type: {
    type: e(String)
  },
  placement: {
    type: e(String),
    default: "bottom"
  },
  popperOptions: {
    type: e(Object),
    default: () => ({})
  },
  id: String,
  size: {
    type: String,
    default: ""
  },
  splitButton: Boolean,
  hideOnClick: {
    type: Boolean,
    default: !0
  },
  loop: {
    type: Boolean,
    default: !0
  },
  showTimeout: {
    type: Number,
    default: 150
  },
  hideTimeout: {
    type: Number,
    default: 150
  },
  tabindex: {
    type: e([Number, String]),
    default: 0
  },
  maxHeight: {
    type: e([Number, String]),
    default: ""
  },
  popperClass: {
    type: String,
    default: ""
  },
  disabled: {
    type: Boolean,
    default: !1
  },
  role: {
    type: String,
    default: "menu"
  },
  buttonProps: {
    type: e(Object)
  },
  teleported: p.teleported
}), O = o({
  command: {
    type: [Object, String, Number],
    default: () => ({})
  },
  disabled: Boolean,
  divided: Boolean,
  textValue: String,
  icon: {
    type: n
  }
}), T = o({
  onKeydown: { type: e(Function) }
}), l = [
  t.down,
  t.pageDown,
  t.home
], d = [t.up, t.pageUp, t.end], y = [...l, ...d], {
  ElCollection: g,
  ElCollectionItem: N,
  COLLECTION_INJECTION_KEY: C,
  COLLECTION_ITEM_INJECTION_KEY: I
} = i("Dropdown");
export {
  C as DROPDOWN_COLLECTION_INJECTION_KEY,
  I as DROPDOWN_COLLECTION_ITEM_INJECTION_KEY,
  g as ElCollection,
  N as ElCollectionItem,
  l as FIRST_KEYS,
  y as FIRST_LAST_KEYS,
  d as LAST_KEYS,
  O as dropdownItemProps,
  T as dropdownMenuProps,
  E as dropdownProps
};
