import { defineComponent as $, ref as V, provide as j, watch as y, unref as m, onMounted as q, onBeforeUnmount as x, nextTick as D, renderSlot as J } from "vue";
import { useFocusReason as M, tryFocus as d, createFocusOutPreventedEvent as T, getEdges as Y, focusableStack as I, focusFirstDescendant as z, obtainAllFocusableElements as G, isFocusCausedByUserEvent as H } from "./utils.js";
import { ON_TRAP_FOCUS_EVT as U, ON_RELEASE_FOCUS_EVT as w, FOCUS_TRAP_INJECTION_KEY as Q, FOCUS_AFTER_TRAPPED as C, FOCUS_AFTER_TRAPPED_OPTS as N, FOCUS_AFTER_RELEASED as O } from "./tokens.js";
import W from "../../../_virtual/plugin-vue_export-helper.js";
import { useEscapeKeydown as X } from "../../../hooks/use-escape-keydown/index.js";
import { EVENT_CODE as Z } from "../../../constants/aria.js";
import { isString as ee } from "../../../../../@vue/shared/dist/shared.esm-bundler.js";
import te from "../../../../../lodash-es/isNil.js";
const ne = $({
  name: "ElFocusTrap",
  inheritAttrs: !1,
  props: {
    loop: Boolean,
    trapped: Boolean,
    focusTrapEl: Object,
    focusStartEl: {
      type: [Object, String],
      default: "first"
    }
  },
  emits: [
    U,
    w,
    "focusin",
    "focusout",
    "focusout-prevented",
    "release-requested"
  ],
  setup(n, { emit: a }) {
    const u = V();
    let l, p;
    const { focusReason: i } = M();
    X((e) => {
      n.trapped && !f.paused && a("release-requested", e);
    });
    const f = {
      paused: !1,
      pause() {
        this.paused = !0;
      },
      resume() {
        this.paused = !1;
      }
    }, v = (e) => {
      if (!n.loop && !n.trapped || f.paused)
        return;
      const { key: t, altKey: s, ctrlKey: o, metaKey: r, currentTarget: h, shiftKey: K } = e, { loop: k } = n, B = t === Z.tab && !s && !o && !r, E = document.activeElement;
      if (B && E) {
        const F = h, [_, P] = Y(F);
        if (_ && P) {
          if (!K && E === P) {
            const c = T({
              focusReason: i.value
            });
            a("focusout-prevented", c), c.defaultPrevented || (e.preventDefault(), k && d(_, !0));
          } else if (K && [_, F].includes(E)) {
            const c = T({
              focusReason: i.value
            });
            a("focusout-prevented", c), c.defaultPrevented || (e.preventDefault(), k && d(P, !0));
          }
        } else if (E === F) {
          const c = T({
            focusReason: i.value
          });
          a("focusout-prevented", c), c.defaultPrevented || e.preventDefault();
        }
      }
    };
    j(Q, {
      focusTrapRef: u,
      onKeydown: v
    }), y(() => n.focusTrapEl, (e) => {
      e && (u.value = e);
    }, { immediate: !0 }), y([u], ([e], [t]) => {
      e && (e.addEventListener("keydown", v), e.addEventListener("focusin", S), e.addEventListener("focusout", L)), t && (t.removeEventListener("keydown", v), t.removeEventListener("focusin", S), t.removeEventListener("focusout", L));
    });
    const b = (e) => {
      a(U, e);
    }, g = (e) => a(w, e), S = (e) => {
      const t = m(u);
      if (!t)
        return;
      const s = e.target, o = e.relatedTarget, r = s && t.contains(s);
      n.trapped || o && t.contains(o) || (l = o), r && a("focusin", e), !f.paused && n.trapped && (r ? p = s : d(p, !0));
    }, L = (e) => {
      const t = m(u);
      if (!(f.paused || !t))
        if (n.trapped) {
          const s = e.relatedTarget;
          !te(s) && !t.contains(s) && setTimeout(() => {
            if (!f.paused && n.trapped) {
              const o = T({
                focusReason: i.value
              });
              a("focusout-prevented", o), o.defaultPrevented || d(p, !0);
            }
          }, 0);
        } else {
          const s = e.target;
          s && t.contains(s) || a("focusout", e);
        }
    };
    async function A() {
      await D();
      const e = m(u);
      if (e) {
        I.push(f);
        const t = e.contains(document.activeElement) ? l : document.activeElement;
        if (l = t, !e.contains(t)) {
          const o = new Event(C, N);
          e.addEventListener(C, b), e.dispatchEvent(o), o.defaultPrevented || D(() => {
            let r = n.focusStartEl;
            ee(r) || (d(r), document.activeElement !== r && (r = "first")), r === "first" && z(G(e), !0), (document.activeElement === t || r === "container") && d(e);
          });
        }
      }
    }
    function R() {
      const e = m(u);
      if (e) {
        e.removeEventListener(C, b);
        const t = new CustomEvent(O, {
          ...N,
          detail: {
            focusReason: i.value
          }
        });
        e.addEventListener(O, g), e.dispatchEvent(t), !t.defaultPrevented && (i.value == "keyboard" || !H() || e.contains(document.activeElement)) && d(l ?? document.body), e.removeEventListener(O, g), I.remove(f);
      }
    }
    return q(() => {
      n.trapped && A(), y(() => n.trapped, (e) => {
        e ? A() : R();
      });
    }), x(() => {
      n.trapped && R();
    }), {
      onKeydown: v
    };
  }
});
function se(n, a, u, l, p, i) {
  return J(n.$slots, "default", { handleKeydown: n.onKeydown });
}
var pe = /* @__PURE__ */ W(ne, [["render", se], ["__file", "/home/runner/work/element-plus/element-plus/packages/components/focus-trap/src/focus-trap.vue"]]);
export {
  pe as default
};
