import { defineComponent as te, computed as c, ref as y, reactive as le, watch as Z, nextTick as T, onMounted as ae, onBeforeUnmount as re, toRefs as ie, resolveComponent as g, openBlock as a, createBlock as d, Transition as ue, withCtx as r, withDirectives as A, createVNode as C, createElementVNode as i, normalizeClass as t, normalizeStyle as j, withModifiers as I, createElementBlock as L, resolveDynamicComponent as S, createCommentVNode as b, toDisplayString as B, withKeys as R, renderSlot as de, createTextVNode as H, vShow as O } from "vue";
import { ElButton as fe } from "../../button/index.js";
import { ElInput as pe } from "../../input/index.js";
import { ElOverlay as me } from "../../overlay/index.js";
import { ElIcon as ve } from "../../icon/index.js";
import ce from "../../../_virtual/plugin-vue_export-helper.js";
import ye from "../../../directives/trap-focus/index.js";
import ge from "../../focus-trap/src/focus-trap.js";
import { TypeComponents as Ce, TypeComponentsMap as J } from "../../../utils/vue/icon.js";
import { isValidComponentSize as be } from "../../../utils/vue/validator.js";
import { useGlobalComponentSettings as he } from "../../config-provider/src/hooks/use-global-config.js";
import { useId as Q } from "../../../hooks/use-id/index.js";
import { useDraggable as Ee } from "../../../hooks/use-draggable/index.js";
import { useSameTarget as Be } from "../../../hooks/use-same-target/index.js";
import { useLockscreen as we } from "../../../hooks/use-lockscreen/index.js";
const Me = te({
  name: "ElMessageBox",
  directives: {
    TrapFocus: ye
  },
  components: {
    ElButton: fe,
    ElFocusTrap: ge,
    ElInput: pe,
    ElOverlay: me,
    ElIcon: ve,
    ...Ce
  },
  inheritAttrs: !1,
  props: {
    buttonSize: {
      type: String,
      validator: be
    },
    modal: {
      type: Boolean,
      default: !0
    },
    lockScroll: {
      type: Boolean,
      default: !0
    },
    showClose: {
      type: Boolean,
      default: !0
    },
    closeOnClickModal: {
      type: Boolean,
      default: !0
    },
    closeOnPressEscape: {
      type: Boolean,
      default: !0
    },
    closeOnHashChange: {
      type: Boolean,
      default: !0
    },
    center: Boolean,
    draggable: Boolean,
    roundButton: {
      default: !1,
      type: Boolean
    },
    container: {
      type: String,
      default: "body"
    },
    boxType: {
      type: String,
      default: ""
    }
  },
  emits: ["vanish", "action"],
  setup(e, { emit: n }) {
    const {
      locale: D,
      zIndex: P,
      ns: z,
      size: K
    } = he("message-box", c(() => e.buttonSize)), { t: f } = D, { nextZIndex: w } = P, p = y(!1), o = le({
      autofocus: !0,
      beforeClose: null,
      callback: null,
      cancelButtonText: "",
      cancelButtonClass: "",
      confirmButtonText: "",
      confirmButtonClass: "",
      customClass: "",
      customStyle: {},
      dangerouslyUseHTMLString: !1,
      distinguishCancelAndClose: !1,
      icon: "",
      inputPattern: null,
      inputPlaceholder: "",
      inputType: "text",
      inputValue: null,
      inputValidator: null,
      inputErrorMessage: "",
      message: null,
      modalFade: !0,
      modalClass: "",
      showCancelButton: !1,
      showConfirmButton: !0,
      type: "",
      title: void 0,
      showInput: !1,
      action: "",
      confirmButtonLoading: !1,
      cancelButtonLoading: !1,
      confirmButtonDisabled: !1,
      editorErrorMessage: "",
      validateError: !1,
      zIndex: w()
    }), V = c(() => {
      const s = o.type;
      return { [z.bm("icon", s)]: s && J[s] };
    }), $ = Q(), l = Q(), X = c(() => o.icon || J[o.type] || ""), Y = c(() => !!o.message), m = y(), U = y(), h = y(), M = y(), q = y(), x = c(() => o.confirmButtonClass);
    Z(() => o.inputValue, async (s) => {
      await T(), e.boxType === "prompt" && s !== null && F();
    }, { immediate: !0 }), Z(() => p.value, (s) => {
      var u, v;
      s && (e.boxType !== "prompt" && (o.autofocus ? h.value = (v = (u = q.value) == null ? void 0 : u.$el) != null ? v : m.value : h.value = m.value), o.zIndex = w()), e.boxType === "prompt" && (s ? T().then(() => {
        var W;
        M.value && M.value.$el && (o.autofocus ? h.value = (W = ne()) != null ? W : m.value : h.value = m.value);
      }) : (o.editorErrorMessage = "", o.validateError = !1));
    });
    const _ = c(() => e.draggable);
    Ee(m, U, _), ae(async () => {
      await T(), e.closeOnHashChange && window.addEventListener("hashchange", E);
    }), re(() => {
      e.closeOnHashChange && window.removeEventListener("hashchange", E);
    });
    function E() {
      p.value && (p.value = !1, T(() => {
        o.action && n("action", o.action);
      }));
    }
    const N = () => {
      e.closeOnClickModal && k(o.distinguishCancelAndClose ? "close" : "cancel");
    }, ee = Be(N), oe = (s) => {
      if (o.inputType !== "textarea")
        return s.preventDefault(), k("confirm");
    }, k = (s) => {
      var u;
      e.boxType === "prompt" && s === "confirm" && !F() || (o.action = s, o.beforeClose ? (u = o.beforeClose) == null || u.call(o, s, o, E) : E());
    }, F = () => {
      if (e.boxType === "prompt") {
        const s = o.inputPattern;
        if (s && !s.test(o.inputValue || ""))
          return o.editorErrorMessage = o.inputErrorMessage || f("el.messagebox.error"), o.validateError = !0, !1;
        const u = o.inputValidator;
        if (typeof u == "function") {
          const v = u(o.inputValue);
          if (v === !1)
            return o.editorErrorMessage = o.inputErrorMessage || f("el.messagebox.error"), o.validateError = !0, !1;
          if (typeof v == "string")
            return o.editorErrorMessage = v, o.validateError = !0, !1;
        }
      }
      return o.editorErrorMessage = "", o.validateError = !1, !0;
    }, ne = () => {
      const s = M.value.$refs;
      return s.input || s.textarea;
    }, G = () => {
      k("close");
    }, se = () => {
      e.closeOnPressEscape && G();
    };
    return e.lockScroll && we(p), {
      ...ie(o),
      ns: z,
      overlayEvent: ee,
      visible: p,
      hasMessage: Y,
      typeClass: V,
      contentId: $,
      inputId: l,
      btnSize: K,
      iconComponent: X,
      confirmButtonClasses: x,
      rootRef: m,
      focusStartRef: h,
      headerRef: U,
      inputRef: M,
      confirmRef: q,
      doClose: E,
      handleClose: G,
      onCloseRequested: se,
      handleWrapperClick: N,
      handleInputEnter: oe,
      handleAction: k,
      t: f
    };
  }
}), ke = ["aria-label", "aria-describedby"], Te = ["aria-label"], Ie = ["id"];
function Se(e, n, D, P, z, K) {
  const f = g("el-icon"), w = g("close"), p = g("el-input"), o = g("el-button"), V = g("el-focus-trap"), $ = g("el-overlay");
  return a(), d(ue, {
    name: "fade-in-linear",
    onAfterLeave: n[11] || (n[11] = (l) => e.$emit("vanish")),
    persisted: ""
  }, {
    default: r(() => [
      A(C($, {
        "z-index": e.zIndex,
        "overlay-class": [e.ns.is("message-box"), e.modalClass],
        mask: e.modal
      }, {
        default: r(() => [
          i("div", {
            role: "dialog",
            "aria-label": e.title,
            "aria-modal": "true",
            "aria-describedby": e.showInput ? void 0 : e.contentId,
            class: t(`${e.ns.namespace.value}-overlay-message-box`),
            onClick: n[8] || (n[8] = (...l) => e.overlayEvent.onClick && e.overlayEvent.onClick(...l)),
            onMousedown: n[9] || (n[9] = (...l) => e.overlayEvent.onMousedown && e.overlayEvent.onMousedown(...l)),
            onMouseup: n[10] || (n[10] = (...l) => e.overlayEvent.onMouseup && e.overlayEvent.onMouseup(...l))
          }, [
            C(V, {
              loop: "",
              trapped: e.visible,
              "focus-trap-el": e.rootRef,
              "focus-start-el": e.focusStartRef,
              onReleaseRequested: e.onCloseRequested
            }, {
              default: r(() => [
                i("div", {
                  ref: "rootRef",
                  class: t([
                    e.ns.b(),
                    e.customClass,
                    e.ns.is("draggable", e.draggable),
                    { [e.ns.m("center")]: e.center }
                  ]),
                  style: j(e.customStyle),
                  tabindex: "-1",
                  onClick: n[7] || (n[7] = I(() => {
                  }, ["stop"]))
                }, [
                  e.title !== null && e.title !== void 0 ? (a(), L("div", {
                    key: 0,
                    ref: "headerRef",
                    class: t(e.ns.e("header"))
                  }, [
                    i("div", {
                      class: t(e.ns.e("title"))
                    }, [
                      e.iconComponent && e.center ? (a(), d(f, {
                        key: 0,
                        class: t([e.ns.e("status"), e.typeClass])
                      }, {
                        default: r(() => [
                          (a(), d(S(e.iconComponent)))
                        ]),
                        _: 1
                      }, 8, ["class"])) : b("v-if", !0),
                      i("span", null, B(e.title), 1)
                    ], 2),
                    e.showClose ? (a(), L("button", {
                      key: 0,
                      type: "button",
                      class: t(e.ns.e("headerbtn")),
                      "aria-label": e.t("el.messagebox.close"),
                      onClick: n[0] || (n[0] = (l) => e.handleAction(e.distinguishCancelAndClose ? "close" : "cancel")),
                      onKeydown: n[1] || (n[1] = R(I((l) => e.handleAction(e.distinguishCancelAndClose ? "close" : "cancel"), ["prevent"]), ["enter"]))
                    }, [
                      C(f, {
                        class: t(e.ns.e("close"))
                      }, {
                        default: r(() => [
                          C(w)
                        ]),
                        _: 1
                      }, 8, ["class"])
                    ], 42, Te)) : b("v-if", !0)
                  ], 2)) : b("v-if", !0),
                  i("div", {
                    id: e.contentId,
                    class: t(e.ns.e("content"))
                  }, [
                    i("div", {
                      class: t(e.ns.e("container"))
                    }, [
                      e.iconComponent && !e.center && e.hasMessage ? (a(), d(f, {
                        key: 0,
                        class: t([e.ns.e("status"), e.typeClass])
                      }, {
                        default: r(() => [
                          (a(), d(S(e.iconComponent)))
                        ]),
                        _: 1
                      }, 8, ["class"])) : b("v-if", !0),
                      e.hasMessage ? (a(), L("div", {
                        key: 1,
                        class: t(e.ns.e("message"))
                      }, [
                        de(e.$slots, "default", {}, () => [
                          e.dangerouslyUseHTMLString ? (a(), d(S(e.showInput ? "label" : "p"), {
                            key: 1,
                            for: e.showInput ? e.inputId : void 0,
                            innerHTML: e.message
                          }, null, 8, ["for", "innerHTML"])) : (a(), d(S(e.showInput ? "label" : "p"), {
                            key: 0,
                            for: e.showInput ? e.inputId : void 0
                          }, {
                            default: r(() => [
                              H(B(e.dangerouslyUseHTMLString ? "" : e.message), 1)
                            ]),
                            _: 1
                          }, 8, ["for"]))
                        ])
                      ], 2)) : b("v-if", !0)
                    ], 2),
                    A(i("div", {
                      class: t(e.ns.e("input"))
                    }, [
                      C(p, {
                        id: e.inputId,
                        ref: "inputRef",
                        modelValue: e.inputValue,
                        "onUpdate:modelValue": n[2] || (n[2] = (l) => e.inputValue = l),
                        type: e.inputType,
                        placeholder: e.inputPlaceholder,
                        "aria-invalid": e.validateError,
                        class: t({ invalid: e.validateError }),
                        onKeydown: R(e.handleInputEnter, ["enter"])
                      }, null, 8, ["id", "modelValue", "type", "placeholder", "aria-invalid", "class", "onKeydown"]),
                      i("div", {
                        class: t(e.ns.e("errormsg")),
                        style: j({
                          visibility: e.editorErrorMessage ? "visible" : "hidden"
                        })
                      }, B(e.editorErrorMessage), 7)
                    ], 2), [
                      [O, e.showInput]
                    ])
                  ], 10, Ie),
                  i("div", {
                    class: t(e.ns.e("btns"))
                  }, [
                    e.showCancelButton ? (a(), d(o, {
                      key: 0,
                      loading: e.cancelButtonLoading,
                      class: t([e.cancelButtonClass]),
                      round: e.roundButton,
                      size: e.btnSize,
                      onClick: n[3] || (n[3] = (l) => e.handleAction("cancel")),
                      onKeydown: n[4] || (n[4] = R(I((l) => e.handleAction("cancel"), ["prevent"]), ["enter"]))
                    }, {
                      default: r(() => [
                        H(B(e.cancelButtonText || e.t("el.messagebox.cancel")), 1)
                      ]),
                      _: 1
                    }, 8, ["loading", "class", "round", "size"])) : b("v-if", !0),
                    A(C(o, {
                      ref: "confirmRef",
                      type: "primary",
                      loading: e.confirmButtonLoading,
                      class: t([e.confirmButtonClasses]),
                      round: e.roundButton,
                      disabled: e.confirmButtonDisabled,
                      size: e.btnSize,
                      onClick: n[5] || (n[5] = (l) => e.handleAction("confirm")),
                      onKeydown: n[6] || (n[6] = R(I((l) => e.handleAction("confirm"), ["prevent"]), ["enter"]))
                    }, {
                      default: r(() => [
                        H(B(e.confirmButtonText || e.t("el.messagebox.confirm")), 1)
                      ]),
                      _: 1
                    }, 8, ["loading", "class", "round", "disabled", "size"]), [
                      [O, e.showConfirmButton]
                    ])
                  ], 2)
                ], 6)
              ]),
              _: 3
            }, 8, ["trapped", "focus-trap-el", "focus-start-el", "onReleaseRequested"])
          ], 42, ke)
        ]),
        _: 3
      }, 8, ["z-index", "overlay-class", "mask"]), [
        [O, e.visible]
      ])
    ]),
    _: 3
  });
}
var Ge = /* @__PURE__ */ ce(Me, [["render", Se], ["__file", "/home/runner/work/element-plus/element-plus/packages/components/message-box/src/index.vue"]]);
export {
  Ge as default
};
