import { defineComponent as M, getCurrentInstance as U, computed as m, ref as N, watch as W, provide as j, h as u } from "vue";
import { ArrowLeft as R, ArrowRight as O } from "../../../../../@element-plus/icons-vue/dist/index.js";
import { elPaginationKey as J } from "./constants.js";
import K from "./components/prev2.js";
import V from "./components/next2.js";
import q from "./components/sizes2.js";
import D from "./components/jumper2.js";
import F from "./components/total2.js";
import G from "./components/pager2.js";
import { buildProps as H, definePropType as Q } from "../../../utils/vue/props/runtime.js";
import { isNumber as o } from "../../../utils/types.js";
import { mutable as X } from "../../../utils/typescript.js";
import { iconPropType as T } from "../../../utils/vue/icon.js";
import { useLocale as Y } from "../../../hooks/use-locale/index.js";
import { useNamespace as Z } from "../../../hooks/use-namespace/index.js";
import { debugWarn as $ } from "../../../utils/error.js";
const a = (e) => typeof e != "number", ee = H({
  pageSize: Number,
  defaultPageSize: Number,
  total: Number,
  pageCount: Number,
  pagerCount: {
    type: Number,
    validator: (e) => o(e) && Math.trunc(e) === e && e > 4 && e < 22 && e % 2 === 1,
    default: 7
  },
  currentPage: Number,
  defaultCurrentPage: Number,
  layout: {
    type: String,
    default: ["prev", "pager", "next", "jumper", "->", "total"].join(", ")
  },
  pageSizes: {
    type: Q(Array),
    default: () => X([10, 20, 30, 40, 50, 100])
  },
  popperClass: {
    type: String,
    default: ""
  },
  prevText: {
    type: String,
    default: ""
  },
  prevIcon: {
    type: T,
    default: () => R
  },
  nextText: {
    type: String,
    default: ""
  },
  nextIcon: {
    type: T,
    default: () => O
  },
  teleported: {
    type: Boolean,
    default: !0
  },
  small: Boolean,
  background: Boolean,
  disabled: Boolean,
  hideOnSinglePage: Boolean
}), te = {
  "update:current-page": (e) => o(e),
  "update:page-size": (e) => o(e),
  "size-change": (e) => o(e),
  "current-change": (e) => o(e),
  "prev-click": (e) => o(e),
  "next-click": (e) => o(e)
}, k = "ElPagination";
var Ce = M({
  name: k,
  props: ee,
  emits: te,
  setup(e, { emit: g, slots: v }) {
    const { t: w } = Y(), i = Z("pagination"), d = U().vnode.props || {}, b = "onUpdate:currentPage" in d || "onUpdate:current-page" in d || "onCurrentChange" in d, h = "onUpdate:pageSize" in d || "onUpdate:page-size" in d || "onSizeChange" in d, B = m(() => {
      if (a(e.total) && a(e.pageCount) || !a(e.currentPage) && !b)
        return !1;
      if (e.layout.includes("sizes")) {
        if (a(e.pageCount)) {
          if (!a(e.total) && !a(e.pageSize) && !h)
            return !1;
        } else if (!h)
          return !1;
      }
      return !0;
    }), z = N(a(e.defaultPageSize) ? 10 : e.defaultPageSize), S = N(a(e.defaultCurrentPage) ? 1 : e.defaultCurrentPage), C = m({
      get() {
        return a(e.pageSize) ? z.value : e.pageSize;
      },
      set(t) {
        a(e.pageSize) && (z.value = t), h && (g("update:page-size", t), g("size-change", t));
      }
    }), l = m(() => {
      let t = 0;
      return a(e.pageCount) ? a(e.total) || (t = Math.max(1, Math.ceil(e.total / C.value))) : t = e.pageCount, t;
    }), n = m({
      get() {
        return a(e.currentPage) ? S.value : e.currentPage;
      },
      set(t) {
        let r = t;
        t < 1 ? r = 1 : t > l.value && (r = l.value), a(e.currentPage) && (S.value = r), b && (g("update:current-page", r), g("current-change", r));
      }
    });
    W(l, (t) => {
      n.value > t && (n.value = t);
    });
    function x(t) {
      n.value = t;
    }
    function I(t) {
      C.value = t;
      const r = l.value;
      n.value > r && (n.value = r);
    }
    function _() {
      e.disabled || (n.value -= 1, g("prev-click", n.value));
    }
    function A() {
      e.disabled || (n.value += 1, g("next-click", n.value));
    }
    function p(t, r) {
      t && (t.props || (t.props = {}), t.props.class = [t.props.class, r].join(" "));
    }
    return j(J, {
      pageCount: l,
      disabled: m(() => e.disabled),
      currentPage: n,
      changeEvent: x,
      handleSizeChange: I
    }), () => {
      var t, r;
      if (!B.value)
        return $(k, w("el.pagination.deprecationWarning")), null;
      if (!e.layout || e.hideOnSinglePage && l.value <= 1)
        return null;
      const f = [], c = [], E = u("div", { class: i.e("rightwrapper") }, c), y = {
        prev: u(K, {
          disabled: e.disabled,
          currentPage: n.value,
          prevText: e.prevText,
          prevIcon: e.prevIcon,
          onClick: _
        }),
        jumper: u(D, {
          size: e.small ? "small" : "default"
        }),
        pager: u(G, {
          currentPage: n.value,
          pageCount: l.value,
          pagerCount: e.pagerCount,
          onChange: x,
          disabled: e.disabled
        }),
        next: u(V, {
          disabled: e.disabled,
          currentPage: n.value,
          pageCount: l.value,
          nextText: e.nextText,
          nextIcon: e.nextIcon,
          onClick: A
        }),
        sizes: u(q, {
          pageSize: C.value,
          pageSizes: e.pageSizes,
          popperClass: e.popperClass,
          disabled: e.disabled,
          teleported: e.teleported,
          size: e.small ? "small" : "default"
        }),
        slot: (r = (t = v == null ? void 0 : v.default) == null ? void 0 : t.call(v)) != null ? r : null,
        total: u(F, { total: a(e.total) ? 0 : e.total })
      }, L = e.layout.split(",").map((s) => s.trim());
      let P = !1;
      return L.forEach((s) => {
        if (s === "->") {
          P = !0;
          return;
        }
        P ? c.push(y[s]) : f.push(y[s]);
      }), p(f[0], i.is("first")), p(f[f.length - 1], i.is("last")), P && c.length > 0 && (p(c[0], i.is("first")), p(c[c.length - 1], i.is("last")), f.push(E)), u("div", {
        class: [
          i.b(),
          i.is("background", e.background),
          {
            [i.m("small")]: e.small
          }
        ]
      }, f);
    };
  }
});
export {
  Ce as default,
  te as paginationEmits,
  ee as paginationProps
};
