import { defineComponent as po, toRefs as uo, computed as g, unref as s, provide as mo, reactive as fo, onMounted as go, nextTick as vo, resolveComponent as b, resolveDirective as yo, withDirectives as q, openBlock as t, createElementBlock as p, normalizeClass as a, withModifiers as c, createVNode as w, withCtx as n, createElementVNode as v, normalizeStyle as O, createBlock as d, Transition as te, Fragment as z, renderList as U, toDisplayString as k, createCommentVNode as f, withKeys as u, vModelText as bo, createSlots as ne, resolveDynamicComponent as ae, renderSlot as E, vShow as ho } from "vue";
import { useResizeObserver as So } from "../../../../../@vueuse/core/index.js";
import { placements as Co } from "../../../../../@popperjs/core/dist/index.js";
import { ElInput as co } from "../../input/index.js";
import { ElTooltip as To } from "../../tooltip/index.js";
import { ElScrollbar as wo } from "../../scrollbar/index.js";
import { ElTag as Oo } from "../../tag/index.js";
import { ElIcon as ko } from "../../icon/index.js";
import { CircleClose as Eo, ArrowDown as Io } from "../../../../../@element-plus/icons-vue/dist/index.js";
import Bo from "./option.js";
import Lo from "./select-dropdown.js";
import { useSelectStates as Mo, useSelect as Ko } from "./useSelect.js";
import { selectKey as $o } from "./token.js";
import zo from "./options.js";
import Vo from "../../../_virtual/plugin-vue_export-helper.js";
import Do from "../../../directives/click-outside/index.js";
import { isValidComponentSize as Po } from "../../../utils/vue/validator.js";
import { useTooltipContentProps as Ro } from "../../tooltip/src/content.js";
import { iconPropType as se } from "../../../utils/vue/icon.js";
import { tagProps as Wo } from "../../tag/src/tag.js";
import { UPDATE_MODEL_EVENT as Q, CHANGE_EVENT as Ao } from "../../../constants/event.js";
import { useNamespace as ie } from "../../../hooks/use-namespace/index.js";
import { useLocale as No } from "../../../hooks/use-locale/index.js";
import { useId as Fo } from "../../../hooks/use-id/index.js";
import { isIOS as Ho } from "../../../../../@vueuse/shared/index.js";
const re = "ElSelect", qo = po({
  name: re,
  componentName: re,
  components: {
    ElInput: co,
    ElSelectMenu: Lo,
    ElOption: Bo,
    ElOptions: zo,
    ElTag: Oo,
    ElScrollbar: wo,
    ElTooltip: To,
    ElIcon: ko
  },
  directives: { ClickOutside: Do },
  props: {
    name: String,
    id: String,
    modelValue: {
      type: [Array, String, Number, Boolean, Object],
      default: void 0
    },
    autocomplete: {
      type: String,
      default: "off"
    },
    automaticDropdown: Boolean,
    size: {
      type: String,
      validator: Po
    },
    effect: {
      type: String,
      default: "light"
    },
    disabled: Boolean,
    clearable: Boolean,
    filterable: Boolean,
    allowCreate: Boolean,
    loading: Boolean,
    popperClass: {
      type: String,
      default: ""
    },
    popperOptions: {
      type: Object,
      default: () => ({})
    },
    remote: Boolean,
    loadingText: String,
    noMatchText: String,
    noDataText: String,
    remoteMethod: Function,
    filterMethod: Function,
    multiple: Boolean,
    multipleLimit: {
      type: Number,
      default: 0
    },
    placeholder: {
      type: String
    },
    defaultFirstOption: Boolean,
    reserveKeyword: {
      type: Boolean,
      default: !0
    },
    valueKey: {
      type: String,
      default: "value"
    },
    collapseTags: Boolean,
    collapseTagsTooltip: Boolean,
    maxCollapseTags: {
      type: Number,
      default: 1
    },
    teleported: Ro.teleported,
    persistent: {
      type: Boolean,
      default: !0
    },
    clearIcon: {
      type: se,
      default: Eo
    },
    fitInputWidth: Boolean,
    suffixIcon: {
      type: se,
      default: Io
    },
    tagType: { ...Wo.type, default: "info" },
    validateEvent: {
      type: Boolean,
      default: !0
    },
    remoteShowSuffix: Boolean,
    suffixTransition: {
      type: Boolean,
      default: !0
    },
    placement: {
      type: String,
      values: Co,
      default: "bottom-start"
    },
    ariaLabel: {
      type: String,
      default: void 0
    }
  },
  emits: [
    Q,
    Ao,
    "remove-tag",
    "clear",
    "visible-change",
    "focus",
    "blur"
  ],
  setup(e, o) {
    const i = ie("select"), j = ie("input"), { t: G } = No(), J = Fo(), y = Mo(e), {
      optionList: I,
      optionsArray: B,
      hoverOption: V,
      selectSize: T,
      readonly: D,
      handleResize: L,
      collapseTagSize: P,
      debouncedOnInputChange: R,
      debouncedQueryChange: m,
      deletePrevTag: M,
      deleteTag: l,
      deleteSelected: h,
      handleOptionSelect: X,
      scrollToOption: pe,
      setSelected: Y,
      resetInputHeight: Z,
      managePlaceholder: de,
      showClose: ue,
      selectDisabled: W,
      iconComponent: me,
      iconReverse: fe,
      showNewOption: ge,
      emptyText: ve,
      toggleLastOptionHitState: ye,
      resetInputState: be,
      handleComposition: he,
      onOptionCreate: Se,
      onOptionDestroy: Ce,
      handleMenuEnter: ce,
      handleFocus: Te,
      focus: we,
      blur: Oe,
      handleBlur: ke,
      handleClearClick: Ee,
      handleClose: Ie,
      handleKeydownEscape: Be,
      toggleMenu: Le,
      selectOption: Me,
      getValueKey: Ke,
      navigateOptions: $e,
      handleDeleteTooltipTag: ze,
      dropMenuVisible: Ve,
      reference: A,
      input: De,
      iOSInput: Pe,
      tooltipRef: x,
      tagTooltipRef: Re,
      tags: We,
      selectWrapper: N,
      scrollbar: Ae,
      queryChange: Ne,
      groupQueryChange: Fe,
      handleMouseEnter: He,
      handleMouseLeave: qe,
      showTagList: Ue,
      collapseTagList: Qe,
      selectTagsStyle: je
    } = Ko(e, y, o), {
      inputWidth: S,
      selected: K,
      inputLength: _,
      filteredOptionsCount: F,
      visible: Ge,
      selectedLabel: Je,
      hoverIndex: ee,
      query: oe,
      inputHovering: Xe,
      currentPlaceholder: H,
      menuVisibleOnFocus: Ye,
      isOnComposition: Ze,
      options: le,
      cachedOptions: xe,
      optionsCount: _e,
      prefixWidth: $
    } = uo(y), eo = g(() => {
      const r = [i.b()], C = s(T);
      return C && r.push(i.m(C)), e.disabled && r.push(i.m("disabled")), r;
    }), oo = g(() => [
      i.e("tags"),
      i.is("disabled", s(W))
    ]), lo = g(() => [
      i.b("tags-wrapper"),
      { "has-prefix": s($) && s(K).length }
    ]), to = g(() => [
      i.e("input"),
      i.is(s(T)),
      i.is("disabled", s(W))
    ]), no = g(() => [
      i.e("input"),
      i.is(s(T)),
      i.em("input", "iOS")
    ]), ao = g(() => [
      i.is("empty", !e.allowCreate && !!s(oe) && s(F) === 0)
    ]), so = g(() => ({ maxWidth: `${s(S) > 123 && s(K).length > e.maxCollapseTags ? s(S) - 123 : s(S) - 75}px` })), io = g(() => ({
      marginLeft: `${s($)}px`,
      flexGrow: 1,
      width: `${s(_) / (s(S) - 32)}%`,
      maxWidth: `${s(S) - 42}px`
    }));
    mo($o, fo({
      props: e,
      options: le,
      optionsArray: B,
      cachedOptions: xe,
      optionsCount: _e,
      filteredOptionsCount: F,
      hoverIndex: ee,
      handleOptionSelect: X,
      onOptionCreate: Se,
      onOptionDestroy: Ce,
      selectWrapper: N,
      selected: K,
      setSelected: Y,
      queryChange: Ne,
      groupQueryChange: Fe
    })), go(() => {
      y.cachedPlaceHolder = H.value = e.placeholder || (() => G("el.select.placeholder")), e.multiple && Array.isArray(e.modelValue) && e.modelValue.length > 0 && (H.value = ""), So(N, L), e.remote && e.multiple && Z(), vo(() => {
        const r = A.value && A.value.$el;
        if (r && (S.value = r.getBoundingClientRect().width, o.slots.prefix)) {
          const C = r.querySelector(`.${j.e("prefix")}`);
          $.value = Math.max(C.getBoundingClientRect().width + 11, 30);
        }
      }), Y();
    }), e.multiple && !Array.isArray(e.modelValue) && o.emit(Q, []), !e.multiple && Array.isArray(e.modelValue) && o.emit(Q, "");
    const ro = g(() => {
      var r, C;
      return (C = (r = x.value) == null ? void 0 : r.popperRef) == null ? void 0 : C.contentRef;
    });
    return {
      isIOS: Ho,
      onOptionsRendered: (r) => {
        I.value = r;
      },
      prefixWidth: $,
      selectSize: T,
      readonly: D,
      handleResize: L,
      collapseTagSize: P,
      debouncedOnInputChange: R,
      debouncedQueryChange: m,
      deletePrevTag: M,
      deleteTag: l,
      handleDeleteTooltipTag: ze,
      deleteSelected: h,
      handleOptionSelect: X,
      scrollToOption: pe,
      inputWidth: S,
      selected: K,
      inputLength: _,
      filteredOptionsCount: F,
      visible: Ge,
      selectedLabel: Je,
      hoverIndex: ee,
      query: oe,
      inputHovering: Xe,
      currentPlaceholder: H,
      menuVisibleOnFocus: Ye,
      isOnComposition: Ze,
      options: le,
      resetInputHeight: Z,
      managePlaceholder: de,
      showClose: ue,
      selectDisabled: W,
      iconComponent: me,
      iconReverse: fe,
      showNewOption: ge,
      emptyText: ve,
      toggleLastOptionHitState: ye,
      resetInputState: be,
      handleComposition: he,
      handleMenuEnter: ce,
      handleFocus: Te,
      focus: we,
      blur: Oe,
      handleBlur: ke,
      handleClearClick: Ee,
      handleClose: Ie,
      handleKeydownEscape: Be,
      toggleMenu: Le,
      selectOption: Me,
      getValueKey: Ke,
      navigateOptions: $e,
      dropMenuVisible: Ve,
      reference: A,
      input: De,
      iOSInput: Pe,
      tooltipRef: x,
      popperPaneRef: ro,
      tags: We,
      selectWrapper: N,
      scrollbar: Ae,
      wrapperKls: eo,
      tagsKls: oo,
      tagWrapperKls: lo,
      inputKls: to,
      iOSInputKls: no,
      scrollbarKls: ao,
      selectTagsStyle: je,
      nsSelect: i,
      tagTextStyle: so,
      inputStyle: io,
      handleMouseEnter: He,
      handleMouseLeave: qe,
      showTagList: Ue,
      collapseTagList: Qe,
      tagTooltipRef: Re,
      contentId: J,
      hoverOption: V
    };
  }
}), Uo = ["disabled", "autocomplete", "aria-activedescendant", "aria-controls", "aria-expanded", "aria-label"], Qo = ["disabled"], jo = { style: { height: "100%", display: "flex", "justify-content": "center", "align-items": "center" } };
function Go(e, o, i, j, G, J) {
  const y = b("el-tag"), I = b("el-tooltip"), B = b("el-icon"), V = b("el-input"), T = b("el-option"), D = b("el-options"), L = b("el-scrollbar"), P = b("el-select-menu"), R = yo("click-outside");
  return q((t(), p("div", {
    ref: "selectWrapper",
    class: a(e.wrapperKls),
    onMouseenter: o[22] || (o[22] = (...m) => e.handleMouseEnter && e.handleMouseEnter(...m)),
    onMouseleave: o[23] || (o[23] = (...m) => e.handleMouseLeave && e.handleMouseLeave(...m)),
    onClick: o[24] || (o[24] = c((...m) => e.toggleMenu && e.toggleMenu(...m), ["stop"]))
  }, [
    w(I, {
      ref: "tooltipRef",
      visible: e.dropMenuVisible,
      placement: e.placement,
      teleported: e.teleported,
      "popper-class": [e.nsSelect.e("popper"), e.popperClass],
      "popper-options": e.popperOptions,
      "fallback-placements": ["bottom-start", "top-start", "right", "left"],
      effect: e.effect,
      pure: "",
      trigger: "click",
      transition: `${e.nsSelect.namespace.value}-zoom-in-top`,
      "stop-popper-mouse-event": !1,
      "gpu-acceleration": !1,
      persistent: e.persistent,
      onShow: e.handleMenuEnter
    }, {
      default: n(() => {
        var m, M;
        return [
          v("div", {
            class: "select-trigger",
            onMouseenter: o[20] || (o[20] = (l) => e.inputHovering = !0),
            onMouseleave: o[21] || (o[21] = (l) => e.inputHovering = !1)
          }, [
            e.multiple ? (t(), p("div", {
              key: 0,
              ref: "tags",
              tabindex: "-1",
              class: a(e.tagsKls),
              style: O(e.selectTagsStyle),
              onClick: o[15] || (o[15] = (...l) => e.focus && e.focus(...l))
            }, [
              e.collapseTags && e.selected.length ? (t(), d(te, {
                key: 0,
                onAfterLeave: e.resetInputHeight
              }, {
                default: n(() => [
                  v("span", {
                    class: a(e.tagWrapperKls)
                  }, [
                    (t(!0), p(z, null, U(e.showTagList, (l) => (t(), d(y, {
                      key: e.getValueKey(l),
                      closable: !e.selectDisabled && !l.isDisabled,
                      size: e.collapseTagSize,
                      hit: l.hitState,
                      type: e.tagType,
                      "disable-transitions": "",
                      onClose: (h) => e.deleteTag(h, l)
                    }, {
                      default: n(() => [
                        v("span", {
                          class: a(e.nsSelect.e("tags-text")),
                          style: O(e.tagTextStyle)
                        }, k(l.currentLabel), 7)
                      ]),
                      _: 2
                    }, 1032, ["closable", "size", "hit", "type", "onClose"]))), 128)),
                    e.selected.length > e.maxCollapseTags ? (t(), d(y, {
                      key: 0,
                      closable: !1,
                      size: e.collapseTagSize,
                      type: e.tagType,
                      "disable-transitions": ""
                    }, {
                      default: n(() => [
                        e.collapseTagsTooltip ? (t(), d(I, {
                          key: 0,
                          ref: "tagTooltipRef",
                          disabled: e.dropMenuVisible,
                          "fallback-placements": ["bottom", "top", "right", "left"],
                          effect: e.effect,
                          placement: "bottom",
                          teleported: e.teleported
                        }, {
                          default: n(() => [
                            v("span", {
                              class: a(e.nsSelect.e("tags-text"))
                            }, "+ " + k(e.selected.length - e.maxCollapseTags), 3)
                          ]),
                          content: n(() => [
                            v("div", {
                              class: a(e.nsSelect.e("collapse-tags"))
                            }, [
                              (t(!0), p(z, null, U(e.collapseTagList, (l) => (t(), p("div", {
                                key: e.getValueKey(l),
                                class: a(e.nsSelect.e("collapse-tag"))
                              }, [
                                w(y, {
                                  class: "in-tooltip",
                                  closable: !e.selectDisabled && !l.isDisabled,
                                  size: e.collapseTagSize,
                                  hit: l.hitState,
                                  type: e.tagType,
                                  "disable-transitions": "",
                                  style: { margin: "2px" },
                                  onClose: (h) => e.handleDeleteTooltipTag(h, l)
                                }, {
                                  default: n(() => [
                                    v("span", {
                                      class: a(e.nsSelect.e("tags-text")),
                                      style: O({
                                        maxWidth: e.inputWidth - 75 + "px"
                                      })
                                    }, k(l.currentLabel), 7)
                                  ]),
                                  _: 2
                                }, 1032, ["closable", "size", "hit", "type", "onClose"])
                              ], 2))), 128))
                            ], 2)
                          ]),
                          _: 1
                        }, 8, ["disabled", "effect", "teleported"])) : (t(), p("span", {
                          key: 1,
                          class: a(e.nsSelect.e("tags-text"))
                        }, "+ " + k(e.selected.length - e.maxCollapseTags), 3))
                      ]),
                      _: 1
                    }, 8, ["size", "type"])) : f("v-if", !0)
                  ], 2)
                ]),
                _: 1
              }, 8, ["onAfterLeave"])) : f("v-if", !0),
              e.collapseTags ? f("v-if", !0) : (t(), d(te, {
                key: 1,
                onAfterLeave: e.resetInputHeight
              }, {
                default: n(() => [
                  v("span", {
                    class: a(e.tagWrapperKls),
                    style: O(e.prefixWidth && e.selected.length ? { marginLeft: `${e.prefixWidth}px` } : "")
                  }, [
                    (t(!0), p(z, null, U(e.selected, (l) => (t(), d(y, {
                      key: e.getValueKey(l),
                      closable: !e.selectDisabled && !l.isDisabled,
                      size: e.collapseTagSize,
                      hit: l.hitState,
                      type: e.tagType,
                      "disable-transitions": "",
                      onClose: (h) => e.deleteTag(h, l)
                    }, {
                      default: n(() => [
                        v("span", {
                          class: a(e.nsSelect.e("tags-text")),
                          style: O({ maxWidth: e.inputWidth - 75 + "px" })
                        }, k(l.currentLabel), 7)
                      ]),
                      _: 2
                    }, 1032, ["closable", "size", "hit", "type", "onClose"]))), 128))
                  ], 6)
                ]),
                _: 1
              }, 8, ["onAfterLeave"])),
              e.filterable && !e.selectDisabled ? q((t(), p("input", {
                key: 2,
                ref: "input",
                "onUpdate:modelValue": o[0] || (o[0] = (l) => e.query = l),
                type: "text",
                class: a(e.inputKls),
                disabled: e.selectDisabled,
                autocomplete: e.autocomplete,
                style: O(e.inputStyle),
                role: "combobox",
                "aria-activedescendant": ((m = e.hoverOption) == null ? void 0 : m.id) || "",
                "aria-controls": e.contentId,
                "aria-expanded": e.dropMenuVisible,
                "aria-label": e.ariaLabel,
                "aria-autocomplete": "none",
                "aria-haspopup": "listbox",
                onFocus: o[1] || (o[1] = (...l) => e.handleFocus && e.handleFocus(...l)),
                onBlur: o[2] || (o[2] = (...l) => e.handleBlur && e.handleBlur(...l)),
                onKeyup: o[3] || (o[3] = (...l) => e.managePlaceholder && e.managePlaceholder(...l)),
                onKeydown: [
                  o[4] || (o[4] = (...l) => e.resetInputState && e.resetInputState(...l)),
                  o[5] || (o[5] = u(c((l) => e.navigateOptions("next"), ["prevent"]), ["down"])),
                  o[6] || (o[6] = u(c((l) => e.navigateOptions("prev"), ["prevent"]), ["up"])),
                  o[7] || (o[7] = u((...l) => e.handleKeydownEscape && e.handleKeydownEscape(...l), ["esc"])),
                  o[8] || (o[8] = u(c((...l) => e.selectOption && e.selectOption(...l), ["stop", "prevent"]), ["enter"])),
                  o[9] || (o[9] = u((...l) => e.deletePrevTag && e.deletePrevTag(...l), ["delete"])),
                  o[10] || (o[10] = u((l) => e.visible = !1, ["tab"]))
                ],
                onCompositionstart: o[11] || (o[11] = (...l) => e.handleComposition && e.handleComposition(...l)),
                onCompositionupdate: o[12] || (o[12] = (...l) => e.handleComposition && e.handleComposition(...l)),
                onCompositionend: o[13] || (o[13] = (...l) => e.handleComposition && e.handleComposition(...l)),
                onInput: o[14] || (o[14] = (...l) => e.debouncedQueryChange && e.debouncedQueryChange(...l))
              }, null, 46, Uo)), [
                [bo, e.query]
              ]) : f("v-if", !0)
            ], 6)) : f("v-if", !0),
            e.isIOS && !e.multiple && e.filterable && e.readonly ? (t(), p("input", {
              key: 1,
              ref: "iOSInput",
              class: a(e.iOSInputKls),
              disabled: e.selectDisabled,
              type: "text"
            }, null, 10, Qo)) : f("v-if", !0),
            w(V, {
              id: e.id,
              ref: "reference",
              modelValue: e.selectedLabel,
              "onUpdate:modelValue": o[16] || (o[16] = (l) => e.selectedLabel = l),
              type: "text",
              placeholder: typeof e.currentPlaceholder == "function" ? e.currentPlaceholder() : e.currentPlaceholder,
              name: e.name,
              autocomplete: e.autocomplete,
              size: e.selectSize,
              disabled: e.selectDisabled,
              readonly: e.readonly,
              "validate-event": !1,
              class: a([e.nsSelect.is("focus", e.visible)]),
              tabindex: e.multiple && e.filterable ? -1 : void 0,
              role: "combobox",
              "aria-activedescendant": ((M = e.hoverOption) == null ? void 0 : M.id) || "",
              "aria-controls": e.contentId,
              "aria-expanded": e.dropMenuVisible,
              label: e.ariaLabel,
              "aria-autocomplete": "none",
              "aria-haspopup": "listbox",
              onFocus: e.handleFocus,
              onBlur: e.handleBlur,
              onInput: e.debouncedOnInputChange,
              onPaste: e.debouncedOnInputChange,
              onCompositionstart: e.handleComposition,
              onCompositionupdate: e.handleComposition,
              onCompositionend: e.handleComposition,
              onKeydown: [
                o[17] || (o[17] = u(c((l) => e.navigateOptions("next"), ["stop", "prevent"]), ["down"])),
                o[18] || (o[18] = u(c((l) => e.navigateOptions("prev"), ["stop", "prevent"]), ["up"])),
                u(c(e.selectOption, ["stop", "prevent"]), ["enter"]),
                u(e.handleKeydownEscape, ["esc"]),
                o[19] || (o[19] = u((l) => e.visible = !1, ["tab"]))
              ]
            }, ne({
              suffix: n(() => [
                e.iconComponent && !e.showClose ? (t(), d(B, {
                  key: 0,
                  class: a([e.nsSelect.e("caret"), e.nsSelect.e("icon"), e.iconReverse])
                }, {
                  default: n(() => [
                    (t(), d(ae(e.iconComponent)))
                  ]),
                  _: 1
                }, 8, ["class"])) : f("v-if", !0),
                e.showClose && e.clearIcon ? (t(), d(B, {
                  key: 1,
                  class: a([e.nsSelect.e("caret"), e.nsSelect.e("icon")]),
                  onClick: e.handleClearClick
                }, {
                  default: n(() => [
                    (t(), d(ae(e.clearIcon)))
                  ]),
                  _: 1
                }, 8, ["class", "onClick"])) : f("v-if", !0)
              ]),
              _: 2
            }, [
              e.$slots.prefix ? {
                name: "prefix",
                fn: n(() => [
                  v("div", jo, [
                    E(e.$slots, "prefix")
                  ])
                ])
              } : void 0
            ]), 1032, ["id", "modelValue", "placeholder", "name", "autocomplete", "size", "disabled", "readonly", "class", "tabindex", "aria-activedescendant", "aria-controls", "aria-expanded", "label", "onFocus", "onBlur", "onInput", "onPaste", "onCompositionstart", "onCompositionupdate", "onCompositionend", "onKeydown"])
          ], 32)
        ];
      }),
      content: n(() => [
        w(P, null, ne({
          default: n(() => [
            q(w(L, {
              id: e.contentId,
              ref: "scrollbar",
              tag: "ul",
              "wrap-class": e.nsSelect.be("dropdown", "wrap"),
              "view-class": e.nsSelect.be("dropdown", "list"),
              class: a(e.scrollbarKls),
              role: "listbox",
              "aria-label": e.ariaLabel,
              "aria-orientation": "vertical"
            }, {
              default: n(() => [
                e.showNewOption ? (t(), d(T, {
                  key: 0,
                  value: e.query,
                  created: !0
                }, null, 8, ["value"])) : f("v-if", !0),
                w(D, { onUpdateOptions: e.onOptionsRendered }, {
                  default: n(() => [
                    E(e.$slots, "default")
                  ]),
                  _: 3
                }, 8, ["onUpdateOptions"])
              ]),
              _: 3
            }, 8, ["id", "wrap-class", "view-class", "class", "aria-label"]), [
              [ho, e.options.size > 0 && !e.loading]
            ]),
            e.emptyText && (!e.allowCreate || e.loading || e.allowCreate && e.options.size === 0) ? (t(), p(z, { key: 0 }, [
              e.$slots.empty ? E(e.$slots, "empty", { key: 0 }) : (t(), p("p", {
                key: 1,
                class: a(e.nsSelect.be("dropdown", "empty"))
              }, k(e.emptyText), 3))
            ], 64)) : f("v-if", !0)
          ]),
          _: 2
        }, [
          e.$slots.header ? {
            name: "header",
            fn: n(() => [
              E(e.$slots, "header")
            ])
          } : void 0,
          e.$slots.footer ? {
            name: "footer",
            fn: n(() => [
              E(e.$slots, "footer")
            ])
          } : void 0
        ]), 1024)
      ]),
      _: 3
    }, 8, ["visible", "placement", "teleported", "popper-class", "popper-options", "effect", "transition", "persistent", "onShow"])
  ], 34)), [
    [R, e.handleClose, e.popperPaneRef]
  ]);
}
var Cl = /* @__PURE__ */ Vo(qo, [["render", Go], ["__file", "/home/runner/work/element-plus/element-plus/packages/components/select/src/select.vue"]]);
export {
  Cl as default
};
