import { defineComponent as T, getCurrentInstance as U, ref as A, computed as d, watch as j, resolveComponent as s, resolveDirective as G, openBlock as a, createBlock as w, withCtx as u, createElementBlock as c, createElementVNode as f, normalizeClass as r, createVNode as F, Fragment as R, renderList as S, createTextVNode as I, toDisplayString as v, withDirectives as L } from "vue";
import { ElCheckbox as O } from "../../checkbox/index.js";
import { ElIcon as z } from "../../icon/index.js";
import { ArrowDown as M, ArrowUp as q } from "../../../../../@element-plus/icons-vue/dist/index.js";
import { ElTooltip as H } from "../../tooltip/index.js";
import { ElScrollbar as J } from "../../scrollbar/index.js";
import K from "../../../_virtual/plugin-vue_export-helper.js";
import Q from "../../../directives/click-outside/index.js";
import { useLocale as W } from "../../../hooks/use-locale/index.js";
import { useNamespace as X } from "../../../hooks/use-namespace/index.js";
const { CheckboxGroup: Y } = O, Z = T({
  name: "ElTableFilterPanel",
  components: {
    ElCheckbox: O,
    ElCheckboxGroup: Y,
    ElScrollbar: J,
    ElTooltip: H,
    ElIcon: z,
    ArrowDown: M,
    ArrowUp: q
  },
  directives: { ClickOutside: Q },
  props: {
    placement: {
      type: String,
      default: "bottom-start"
    },
    store: {
      type: Object
    },
    column: {
      type: Object
    },
    upDataColumn: {
      type: Function
    }
  },
  setup(e) {
    const n = U(), { t: P } = W(), D = X("table-filter"), h = n == null ? void 0 : n.parent;
    h.filterPanels.value[e.column.id] || (h.filterPanels.value[e.column.id] = n);
    const i = A(!1), b = A(null), C = d(() => e.column && e.column.filters), m = d({
      get: () => {
        var l;
        return (((l = e.column) == null ? void 0 : l.filteredValue) || [])[0];
      },
      set: (l) => {
        o.value && (typeof l < "u" && l !== null ? o.value.splice(0, 1, l) : o.value.splice(0, 1));
      }
    }), o = d({
      get() {
        return e.column ? e.column.filteredValue || [] : [];
      },
      set(l) {
        e.column && e.upDataColumn("filteredValue", l);
      }
    }), g = d(() => e.column ? e.column.filterMultiple : !0), V = (l) => l.value === m.value, p = () => {
      i.value = !1;
    }, y = (l) => {
      l.stopPropagation(), i.value = !i.value;
    }, t = () => {
      i.value = !1;
    }, E = () => {
      k(o.value), p();
    }, N = () => {
      o.value = [], k(o.value), p();
    }, _ = (l) => {
      m.value = l, k(typeof l < "u" && l !== null ? o.value : []), p();
    }, k = (l) => {
      e.store.commit("filterChange", {
        column: e.column,
        values: l
      }), e.store.updateAllSelected();
    };
    j(i, (l) => {
      e.column && e.upDataColumn("filterOpened", l);
    }, {
      immediate: !0
    });
    const B = d(() => {
      var l, $;
      return ($ = (l = b.value) == null ? void 0 : l.popperRef) == null ? void 0 : $.contentRef;
    });
    return {
      tooltipVisible: i,
      multiple: g,
      filteredValue: o,
      filterValue: m,
      filters: C,
      handleConfirm: E,
      handleReset: N,
      handleSelect: _,
      isActive: V,
      t: P,
      ns: D,
      showFilterPanel: y,
      hideFilterPanel: t,
      popperPaneRef: B,
      tooltip: b
    };
  }
}), x = { key: 0 }, ee = ["disabled"], le = ["label", "onClick"];
function te(e, n, P, D, h, i) {
  const b = s("el-checkbox"), C = s("el-checkbox-group"), m = s("el-scrollbar"), o = s("arrow-up"), g = s("arrow-down"), V = s("el-icon"), p = s("el-tooltip"), y = G("click-outside");
  return a(), w(p, {
    ref: "tooltip",
    visible: e.tooltipVisible,
    offset: 0,
    placement: e.placement,
    "show-arrow": !1,
    "stop-popper-mouse-event": !1,
    teleported: "",
    effect: "light",
    pure: "",
    "popper-class": e.ns.b(),
    persistent: ""
  }, {
    content: u(() => [
      e.multiple ? (a(), c("div", x, [
        f("div", {
          class: r(e.ns.e("content"))
        }, [
          F(m, {
            "wrap-class": e.ns.e("wrap")
          }, {
            default: u(() => [
              F(C, {
                modelValue: e.filteredValue,
                "onUpdate:modelValue": n[0] || (n[0] = (t) => e.filteredValue = t),
                class: r(e.ns.e("checkbox-group"))
              }, {
                default: u(() => [
                  (a(!0), c(R, null, S(e.filters, (t) => (a(), w(b, {
                    key: t.value,
                    label: t.value
                  }, {
                    default: u(() => [
                      I(v(t.text), 1)
                    ]),
                    _: 2
                  }, 1032, ["label"]))), 128))
                ]),
                _: 1
              }, 8, ["modelValue", "class"])
            ]),
            _: 1
          }, 8, ["wrap-class"])
        ], 2),
        f("div", {
          class: r(e.ns.e("bottom"))
        }, [
          f("button", {
            class: r({ [e.ns.is("disabled")]: e.filteredValue.length === 0 }),
            disabled: e.filteredValue.length === 0,
            type: "button",
            onClick: n[1] || (n[1] = (...t) => e.handleConfirm && e.handleConfirm(...t))
          }, v(e.t("el.table.confirmFilter")), 11, ee),
          f("button", {
            type: "button",
            onClick: n[2] || (n[2] = (...t) => e.handleReset && e.handleReset(...t))
          }, v(e.t("el.table.resetFilter")), 1)
        ], 2)
      ])) : (a(), c("ul", {
        key: 1,
        class: r(e.ns.e("list"))
      }, [
        f("li", {
          class: r([
            e.ns.e("list-item"),
            {
              [e.ns.is("active")]: e.filterValue === void 0 || e.filterValue === null
            }
          ]),
          onClick: n[3] || (n[3] = (t) => e.handleSelect(null))
        }, v(e.t("el.table.clearFilter")), 3),
        (a(!0), c(R, null, S(e.filters, (t) => (a(), c("li", {
          key: t.value,
          class: r([e.ns.e("list-item"), e.ns.is("active", e.isActive(t))]),
          label: t.value,
          onClick: (E) => e.handleSelect(t.value)
        }, v(t.text), 11, le))), 128))
      ], 2))
    ]),
    default: u(() => [
      L((a(), c("span", {
        class: r([
          `${e.ns.namespace.value}-table__column-filter-trigger`,
          `${e.ns.namespace.value}-none-outline`
        ]),
        onClick: n[4] || (n[4] = (...t) => e.showFilterPanel && e.showFilterPanel(...t))
      }, [
        F(V, null, {
          default: u(() => [
            e.column.filterOpened ? (a(), w(o, { key: 0 })) : (a(), w(g, { key: 1 }))
          ]),
          _: 1
        })
      ], 2)), [
        [y, e.hideFilterPanel, e.popperPaneRef]
      ])
    ]),
    _: 1
  }, 8, ["visible", "placement", "popper-class"]);
}
var de = /* @__PURE__ */ K(Z, [["render", te], ["__file", "/home/runner/work/element-plus/element-plus/packages/components/table/src/filter-panel.vue"]]);
export {
  de as default
};
