import { defineComponent as oe, getCurrentInstance as le, provide as re, computed as k, resolveComponent as p, resolveDirective as te, openBlock as r, createElementBlock as i, normalizeClass as o, normalizeStyle as u, createElementVNode as t, renderSlot as L, withDirectives as T, createVNode as s, createCommentVNode as a, withCtx as se, createBlock as H, createTextVNode as ae, toDisplayString as ne, vShow as M } from "vue";
import { ElScrollbar as de } from "../../scrollbar/index.js";
import { createStore as ie } from "./store/helper.js";
import ue from "./table-layout.js";
import me from "./table-header/index.js";
import pe from "./table-body/index.js";
import be from "./table-footer/index.js";
import ye from "./table/utils-helper.js";
import fe from "./table/style-helper.js";
import he from "./table/key-render-helper.js";
import ce from "./table/defaults.js";
import { TABLE_INJECTION_KEY as we } from "./tokens.js";
import { hColgroup as ve } from "./h-helper.js";
import { useScrollbar as Se } from "./composables/use-scrollbar.js";
import ge from "../../../_virtual/plugin-vue_export-helper.js";
import ke from "../../../directives/mousewheel/index.js";
import { useLocale as Le } from "../../../hooks/use-locale/index.js";
import { useNamespace as Te } from "../../../hooks/use-namespace/index.js";
import Ce from "../../../../../lodash-es/debounce.js";
let Ee = 1;
const Ve = oe({
  name: "ElTable",
  directives: {
    Mousewheel: ke
  },
  components: {
    TableHeader: me,
    TableBody: pe,
    TableFooter: be,
    ElScrollbar: de,
    hColgroup: ve
  },
  props: ce,
  emits: [
    "select",
    "select-all",
    "selection-change",
    "cell-mouse-enter",
    "cell-mouse-leave",
    "cell-contextmenu",
    "cell-click",
    "cell-dblclick",
    "row-click",
    "row-contextmenu",
    "row-dblclick",
    "header-click",
    "header-contextmenu",
    "sort-change",
    "filter-change",
    "current-change",
    "header-dragend",
    "expand-change"
  ],
  setup(e) {
    const { t: n } = Le(), c = Te("table"), l = le();
    re(we, l);
    const d = ie(l, e);
    l.store = d;
    const b = new ue({
      store: l.store,
      table: l,
      fit: e.fit,
      showHeader: e.showHeader
    });
    l.layout = b;
    const m = k(() => (d.states.data.value || []).length === 0), {
      setCurrentRow: y,
      getSelectionRows: w,
      toggleRowSelection: f,
      clearSelection: v,
      clearFilter: h,
      toggleAllSelection: S,
      toggleRowExpansion: $,
      clearSort: D,
      sort: R
    } = ye(d), {
      isHidden: z,
      renderExpanded: N,
      setDragVisible: I,
      isGroup: C,
      handleMouseLeave: W,
      handleHeaderFooterMousewheel: F,
      tableSize: G,
      emptyBlockStyle: P,
      handleFixedMousewheel: A,
      resizeProxyVisible: O,
      bodyWidth: K,
      resizeState: E,
      doLayout: g,
      tableBodyStyles: U,
      tableLayout: Y,
      scrollbarViewStyle: J,
      tableInnerStyle: X,
      scrollbarStyle: j
    } = fe(e, b, d, l), { scrollBarRef: q, scrollTo: Q, setScrollLeft: Z, setScrollTop: x } = Se(), V = Ce(g, 50), B = `${c.namespace.value}-table_${Ee++}`;
    l.tableId = B, l.state = {
      isGroup: C,
      resizeState: E,
      doLayout: g,
      debouncedUpdateLayout: V
    };
    const _ = k(() => e.sumText || n("el.table.sumText")), ee = k(() => e.emptyText || n("el.table.emptyText"));
    return he(l), {
      ns: c,
      layout: b,
      store: d,
      handleHeaderFooterMousewheel: F,
      handleMouseLeave: W,
      tableId: B,
      tableSize: G,
      isHidden: z,
      isEmpty: m,
      renderExpanded: N,
      resizeProxyVisible: O,
      resizeState: E,
      isGroup: C,
      bodyWidth: K,
      tableBodyStyles: U,
      emptyBlockStyle: P,
      debouncedUpdateLayout: V,
      handleFixedMousewheel: A,
      setCurrentRow: y,
      getSelectionRows: w,
      toggleRowSelection: f,
      clearSelection: v,
      clearFilter: h,
      toggleAllSelection: S,
      toggleRowExpansion: $,
      clearSort: D,
      doLayout: g,
      sort: R,
      t: n,
      setDragVisible: I,
      context: l,
      computedSumText: _,
      computedEmptyText: ee,
      tableLayout: Y,
      scrollbarViewStyle: J,
      tableInnerStyle: X,
      scrollbarStyle: j,
      scrollBarRef: q,
      scrollTo: Q,
      setScrollLeft: Z,
      setScrollTop: x
    };
  }
}), Be = ["data-prefix"], He = {
  ref: "hiddenColumns",
  class: "hidden-columns"
};
function Me(e, n, c, l, d, b) {
  const m = p("hColgroup"), y = p("table-header"), w = p("table-body"), f = p("table-footer"), v = p("el-scrollbar"), h = te("mousewheel");
  return r(), i("div", {
    ref: "tableWrapper",
    class: o([
      {
        [e.ns.m("fit")]: e.fit,
        [e.ns.m("striped")]: e.stripe,
        [e.ns.m("border")]: e.border || e.isGroup,
        [e.ns.m("hidden")]: e.isHidden,
        [e.ns.m("group")]: e.isGroup,
        [e.ns.m("fluid-height")]: e.maxHeight,
        [e.ns.m("scrollable-x")]: e.layout.scrollX.value,
        [e.ns.m("scrollable-y")]: e.layout.scrollY.value,
        [e.ns.m("enable-row-hover")]: !e.store.states.isComplex.value,
        [e.ns.m("enable-row-transition")]: (e.store.states.data.value || []).length !== 0 && (e.store.states.data.value || []).length < 100,
        "has-footer": e.showSummary
      },
      e.ns.m(e.tableSize),
      e.className,
      e.ns.b(),
      e.ns.m(`layout-${e.tableLayout}`)
    ]),
    style: u(e.style),
    "data-prefix": e.ns.namespace.value,
    onMouseleave: n[0] || (n[0] = (...S) => e.handleMouseLeave && e.handleMouseLeave(...S))
  }, [
    t("div", {
      class: o(e.ns.e("inner-wrapper")),
      style: u(e.tableInnerStyle)
    }, [
      t("div", He, [
        L(e.$slots, "default")
      ], 512),
      e.showHeader && e.tableLayout === "fixed" ? T((r(), i("div", {
        key: 0,
        ref: "headerWrapper",
        class: o(e.ns.e("header-wrapper"))
      }, [
        t("table", {
          ref: "tableHeader",
          class: o(e.ns.e("header")),
          style: u(e.tableBodyStyles),
          border: "0",
          cellpadding: "0",
          cellspacing: "0"
        }, [
          s(m, {
            columns: e.store.states.columns.value,
            "table-layout": e.tableLayout
          }, null, 8, ["columns", "table-layout"]),
          s(y, {
            ref: "tableHeaderRef",
            border: e.border,
            "default-sort": e.defaultSort,
            store: e.store,
            onSetDragVisible: e.setDragVisible
          }, null, 8, ["border", "default-sort", "store", "onSetDragVisible"])
        ], 6)
      ], 2)), [
        [h, e.handleHeaderFooterMousewheel]
      ]) : a("v-if", !0),
      t("div", {
        ref: "bodyWrapper",
        class: o(e.ns.e("body-wrapper"))
      }, [
        s(v, {
          ref: "scrollBarRef",
          "view-style": e.scrollbarViewStyle,
          "wrap-style": e.scrollbarStyle,
          always: e.scrollbarAlwaysOn
        }, {
          default: se(() => [
            t("table", {
              ref: "tableBody",
              class: o(e.ns.e("body")),
              cellspacing: "0",
              cellpadding: "0",
              border: "0",
              style: u({
                width: e.bodyWidth,
                tableLayout: e.tableLayout
              })
            }, [
              s(m, {
                columns: e.store.states.columns.value,
                "table-layout": e.tableLayout
              }, null, 8, ["columns", "table-layout"]),
              e.showHeader && e.tableLayout === "auto" ? (r(), H(y, {
                key: 0,
                ref: "tableHeaderRef",
                class: o(e.ns.e("body-header")),
                border: e.border,
                "default-sort": e.defaultSort,
                store: e.store,
                onSetDragVisible: e.setDragVisible
              }, null, 8, ["class", "border", "default-sort", "store", "onSetDragVisible"])) : a("v-if", !0),
              s(w, {
                context: e.context,
                highlight: e.highlightCurrentRow,
                "row-class-name": e.rowClassName,
                "tooltip-effect": e.tooltipEffect,
                "tooltip-options": e.tooltipOptions,
                "row-style": e.rowStyle,
                store: e.store,
                stripe: e.stripe
              }, null, 8, ["context", "highlight", "row-class-name", "tooltip-effect", "tooltip-options", "row-style", "store", "stripe"]),
              e.showSummary && e.tableLayout === "auto" ? (r(), H(f, {
                key: 1,
                class: o(e.ns.e("body-footer")),
                border: e.border,
                "default-sort": e.defaultSort,
                store: e.store,
                "sum-text": e.computedSumText,
                "summary-method": e.summaryMethod
              }, null, 8, ["class", "border", "default-sort", "store", "sum-text", "summary-method"])) : a("v-if", !0)
            ], 6),
            e.isEmpty ? (r(), i("div", {
              key: 0,
              ref: "emptyBlock",
              style: u(e.emptyBlockStyle),
              class: o(e.ns.e("empty-block"))
            }, [
              t("span", {
                class: o(e.ns.e("empty-text"))
              }, [
                L(e.$slots, "empty", {}, () => [
                  ae(ne(e.computedEmptyText), 1)
                ])
              ], 2)
            ], 6)) : a("v-if", !0),
            e.$slots.append ? (r(), i("div", {
              key: 1,
              ref: "appendWrapper",
              class: o(e.ns.e("append-wrapper"))
            }, [
              L(e.$slots, "append")
            ], 2)) : a("v-if", !0)
          ]),
          _: 3
        }, 8, ["view-style", "wrap-style", "always"])
      ], 2),
      e.showSummary && e.tableLayout === "fixed" ? T((r(), i("div", {
        key: 1,
        ref: "footerWrapper",
        class: o(e.ns.e("footer-wrapper"))
      }, [
        t("table", {
          class: o(e.ns.e("footer")),
          cellspacing: "0",
          cellpadding: "0",
          border: "0",
          style: u(e.tableBodyStyles)
        }, [
          s(m, {
            columns: e.store.states.columns.value,
            "table-layout": e.tableLayout
          }, null, 8, ["columns", "table-layout"]),
          s(f, {
            border: e.border,
            "default-sort": e.defaultSort,
            store: e.store,
            "sum-text": e.computedSumText,
            "summary-method": e.summaryMethod
          }, null, 8, ["border", "default-sort", "store", "sum-text", "summary-method"])
        ], 6)
      ], 2)), [
        [M, !e.isEmpty],
        [h, e.handleHeaderFooterMousewheel]
      ]) : a("v-if", !0),
      e.border || e.isGroup ? (r(), i("div", {
        key: 2,
        class: o(e.ns.e("border-left-patch"))
      }, null, 2)) : a("v-if", !0)
    ], 6),
    T(t("div", {
      ref: "resizeProxy",
      class: o(e.ns.e("column-resize-proxy"))
    }, null, 2), [
      [M, e.resizeProxyVisible]
    ])
  ], 46, Be);
}
var Qe = /* @__PURE__ */ ge(Ve, [["render", Me], ["__file", "/home/runner/work/element-plus/element-plus/packages/components/table/src/table.vue"]]);
export {
  Qe as default
};
