import formUtil from "../../../utils/formUtil.js";
import getJsonAsyncUtil from "../../../utils/getJsonAsyncUtil.js";
import { converFormValueByFieldName } from "./interface/setFormValue.js";
import { calcTable } from "./util/calcTable.js";
import store from "../../../store/index.js";
import { getFormValue } from "./interface/getFormValue.js";
import { reactive } from "vue";
async function initOption(t, e) {
  const a = t.formId;
  let l = await getJsonAsyncUtil(a, "form", t.initOption), m = initFormClass(l);
  l.init = {
    formClass: m
  };
  let { pramDicItem: r, dicKeyData: f } = await initParmDic(l);
  l.init.pramDicItem = r, l.init.dicKeyData = f, e(l);
}
function initFormClass(t) {
  let e = "";
  return t.isExpand === !0 ? t.query === "query" ? e += "h-form-expand query" : e += "h-form-expand" : t.query === "query" ? e += "h-form-layout-query" : e += "h-form", e;
}
function initTableData(t) {
  let e = t.value.filter((l) => {
    if (l.isShow)
      return !0;
    if (l.state && l.state.length > 0) {
      for (let m of l.state)
        if (m.isShow !== !1)
          return !0;
    } else if (l.fieldType == "empty" || l.fieldType == "label")
      return !0;
  }), a = new Array();
  for (let l of e) {
    let m = l.rowIndex, r = l.colIndex;
    if (a[m] || (a[m] = {}), l.useState) {
      let f = l.state.find((n) => l.useState === n.id);
      l = Object.assign(l, f);
    }
    a[m][r] = l;
  }
  return a;
}
function initState(t) {
  let e = {}, a = t.formItem, l = getFormItems(a);
  for (let m in l) {
    let r = l[m];
    if (r.fieldType === "empty" || r.isHiddenField === !0)
      continue;
    let f = r.state, n = r.useState;
    if (f && n)
      for (let o of f) {
        o.id == n && (r = Object.assign(r, o));
        let u = o.condition, d = Array.from(formUtil.doExpression(u));
        for (let s of d)
          e[s] ? e[s].push(Object.assign({}, r, o)) : e[s] = [Object.assign({}, r, o)];
      }
  }
  return e;
}
async function initParmDic(t) {
  let e = {}, a = t.formItem, l = [], m = getFormItems(a);
  for (let n in m) {
    let o = m[n];
    if (o.fieldType === "empty" || o.isHiddenField === !0)
      continue;
    let u = o.state, d = o.useState;
    if (u && d)
      for (let s of u)
        s.id == d ? o = Object.assign(o, s) : parseParmDic(e, l, s);
    parseParmDic(e, l, o);
  }
  let r = [], f = {};
  for (let n in l)
    r.push(l[n].dicKey);
  r = Array.from(new Set(r));
  try {
    if (r.length > 0) {
      f = await formUtil.getParmDicSync(r);
      for (let n in l)
        e[l[n].fieldName] = f[l[n].dicKey];
    }
  } catch {
  }
  return {
    pramDicItem: e,
    dicKeyData: f
  };
}
function parseParmDic(t, e, a) {
  let l = a.dicKey;
  if (!formUtil.isEmpty(l))
    if (a.optionType == "2") {
      let m = {};
      m.dicKey = l, m.fieldName = a.fieldName, m.value = a.value, e.push(m);
    } else
      a.optionType == "1" && (t[a.fieldName] = a.dicItem);
}
function getFormItems(t) {
  let e = [];
  for (let a in t)
    if (t[a].fieldType === "group") {
      let l = t[a].group;
      for (let m in l)
        e.push(l[m]);
    } else
      e.push(t[a]);
  return e;
}
function initEvent(t, e, a) {
  let l = {};
  for (let m in t) {
    let r = t[m];
    if (!(r.fieldType === "empty" || r.isHiddenField === !0))
      try {
        let f = r.events, n = {};
        for (let o in f) {
          const u = formUtil.parentVmExist(
            e,
            f[o].callback
          );
          n[f[o].type] = u[f[o].callback];
        }
        l[r.fieldName] = n;
      } catch (f) {
        console.error("事件解析错误：" + f), l[r.fieldName] = {};
      }
  }
  return reactive(l);
}
function changeState(pramDicItem, dicKeyData, formItems, originalTableData, state, formData, formDataRef) {
  let otd = formUtil.clone(originalTableData);
  if (JSON.stringify(state) == "{}")
    return otd;
  let fieldNames = Object.keys(state);
  for (let key of fieldNames) {
    let stateArr = state[key];
    for (let item of stateArr) {
      let condition = item.condition, keys = formUtil.doExpression(condition);
      for (let t of keys.values()) {
        let e = formData[t];
        /* formUtil.isNumber(value) || */
        e === !0 || e === !1 || e === "true" || e === "false" ? condition = condition.replaceAll("${" + t + "}", e) : condition = condition.replaceAll("${" + t + "}", `'${e}'`);
      }
      if (eval(condition)) {
        let t = formItems.find((a) => item.fieldName == a.fieldName);
        Object.assign(t, item), item.optionType == "2" && item.dicKey && (pramDicItem[item.fieldName] = dicKeyData[item.dicKey]);
        let e = formData[t.fieldName];
        item.fieldType === "text" && e && (item.dataType === "money(yuan)" ? e = formUtil.formatMoney(e) : item.dataType === "money(qian)" ? (e = formUtil.numDiv(e, 1e3), e = formUtil.formatMoney(e)) : item.dataType === "money(wan)" ? (e = formUtil.numDiv(e, 1e4), e = formUtil.formatMoney(e)) : item.dataType === "money(baiwan)" ? (e = formUtil.numDiv(e, 1e6), e = formUtil.formatMoney(e)) : item.dataType === "money(yi)" ? (e = formUtil.numDiv(e, 1e8), e = formUtil.formatMoney(e)) : item.dataType === "percentile" ? e = formUtil.numMulti(e, 100) : item.dataType === "thousand" ? e = formUtil.numMulti(e, 1e3) : item.dataType === "tenThousand" && (e = formUtil.numMulti(e, 1e4)), formDataRef.value[item.fieldName] = e), otd[item.rowIndex][item.colIndex] = item;
      }
    }
  }
  const columnsNum = otd.length == 0 ? 2 : Object.keys(otd[0]).length;
  return otd = calcTable(otd, columnsNum), otd;
}
function initRule(formItems, parentVm, formData) {
  let rules = {};
  for (let i in formItems) {
    let item = formItems[i];
    if (!(item.fieldType === "empty" || item.isHiddenField === !0))
      try {
        let formRules = item.rules, fieldNameRules = [];
        if (item.fieldType === "text") {
          let t = item.dataType;
          if (t === "int") {
            let e = {};
            e.validator = formUtil.validateInt, e.trigger = "blur", fieldNameRules.push(e);
          } else if (t == "double(2)" || t == "double(4)" || t == "double(6)" || t == "percentile" || t === "thousand" || t == "tenThousand") {
            let e = {};
            e.validator = formUtil.validateNumber, e.trigger = "blur", fieldNameRules.push(e);
          } else if (t === "money(yuan)" || t === "money(qian)" || t == "money(wan)" || t == "money(baiwan)" || t == "money(yi)") {
            let e = {};
            e.validator = formUtil.validateMoney, e.trigger = "blur", fieldNameRules.push(e);
          }
        }
        for (let k in formRules) {
          let fieldNameRule = {}, trigger = "input", message = "", type = "";
          if (formRules[k].type === "required")
            formUtil.isEmpty(item.formItem) || (item.formItem.required = !0), item.readOnly && (trigger = "change"), fieldNameRule.required = !0, message = item.label + "不能为空";
          else if (formRules[k].type === "validator") {
            (item.fieldType == "select" || item.fieldType == "multipleSelection" || item.fieldType == "radio" || item.fieldType == "checkbox") && (trigger = "change");
            const t = formUtil.parentVmExist(
              parentVm,
              formRules[k].validator
            );
            t && (fieldNameRule.validator, fieldNameRule.validator = t[formRules[k].validator]);
          } else if (formRules[k].type === "number") {
            let ruleExpr = formRules[k].ruleExpr;
            fieldNameRule.validator = (rule, value, callback) => {
              if (!value) {
                callback();
                return;
              }
              item.dataType == "money(yuan)" ? value = formUtil.delcommafy(value) : item.dataType == "money(wan)" ? (value = formUtil.delcommafy(value), value = formUtil.numMulti(value, 1e4)) : item.dataType == "money(qian)" ? (value = formUtil.delcommafy(value), value = formUtil.numMulti(value, 1e3)) : item.dataType == "money(baiwan)" ? (value = formUtil.delcommafy(value), value = formUtil.numMulti(value, 1e6)) : item.dataType == "money(yi)" ? (value = formUtil.delcommafy(value), value = formUtil.numMulti(value, 1e8)) : item.dataType === "percentile" ? value = formUtil.numDiv(value, 100) : item.dataType === "thousand" ? value = formUtil.numDiv(value, 1e3) : item.dataType === "tenThousand" && (value = formUtil.numDiv(value, 1e4));
              const data = getFormValue(formItems, formData.value);
              let expr = ruleExpr.replace(
                new RegExp("\\$\\{this\\}", "gm"),
                value
              );
              for (let t in data) {
                if (expr.indexOf(t) == -1)
                  continue;
                let e = data[t];
                if (e == "" || isNaN(e)) {
                  callback();
                  return;
                }
                expr = expr.replace(
                  new RegExp("\\$\\{" + t + "\\}", "gm"),
                  e
                );
              }
              try {
                let validFlag = eval(expr);
                validFlag ? callback() : callback(new Error(rule.message));
              } catch (t) {
                callback(new Error(rule.message));
              }
            }, message = "请输入正确的数值";
          } else if (formRules[k].type === "date") {
            let ruleDateExpr = formRules[k].ruleExpr, resDate = (t, e) => {
              let a;
              for (let l in formItems)
                if (formItems[l].fieldName == t) {
                  a = formItems[l];
                  break;
                }
              if (a && (a.fieldType == "date" || a.fieldType == "time" || a.fieldType == "datetime")) {
                let l = a.dateFormat.format, m = a.dateFormat.valueFormat, r = formUtil.formatDate(e, m);
                return r && r instanceof Date && !isNaN(r.getTime()) ? r.getTime() : e;
              }
            };
            fieldNameRule.validator = (rule, value, callback) => {
              if (!value) {
                callback();
                return;
              }
              value = resDate(item.fieldName, value);
              const data = getFormValue(formItems, formData.value);
              let expr = ruleDateExpr.replace(
                new RegExp("\\$\\{this\\}", "gm"),
                value
              );
              for (let t in data) {
                if (expr.indexOf(t) == -1)
                  continue;
                let e = data[t];
                if (!e) {
                  callback();
                  return;
                }
                e = resDate(t, e), expr = expr.replace(
                  new RegExp("\\$\\{" + t + "\\}", "gm"),
                  e
                );
              }
              try {
                let validFlag = eval(expr);
                validFlag ? callback() : callback(new Error(rule.message));
              } catch (t) {
              }
            }, message = "请输入正确的日期";
          } else if (formRules[k].type === "email")
            message = item.label + "格式不正确", type = "email";
          else if (formRules[k].type === "phone")
            message = "请输入正确的手机号码", fieldNameRule.pattern = /^((\+?86)|(\(\+86\)))?(13[012356789][0-9]{8}|15[012356789][0-9]{8}|18[02356789][0-9]{8}|147[0-9]{8}|1349[0-9]{7})$/;
          else if (formRules[k].type === "mobile")
            message = "请输入正确的电话", fieldNameRule.pattern = /^([0-9]{3,4}-)?[0-9]{7,8}$/;
          else if (formRules[k].type === "mobilephone") {
            let t = function(e) {
              var a = /^([0-9]{3,4}-)?[0-9]{7,8}$/, l = /^((\+?86)|(\(\+86\)))?(13[012356789][0-9]{8}|15[012356789][0-9]{8}|18[02356789][0-9]{8}|147[0-9]{8}|1349[0-9]{7})$/;
              return !!(l.test(e) || a.test(e));
            };
            message = "请输入正确的联系电话", fieldNameRule.validator = (e, a, l) => {
              if (!a) {
                l();
                return;
              }
              t(a) ? l() : l(new Error(e.message));
            };
          } else
            formRules[k].type === "idNo" ? fieldNameRule.validator = formUtil.validateIdNo : formRules[k].type === "usci" && (message = "请输入正确的社会信用代码", fieldNameRule.pattern = /^([0-9A-HJ-NPQRTUWXY]{2}\d{6}[0-9A-HJ-NPQRTUWXY]{10}|[1-9]\d{14})$/);
          (item.fieldType === "checkbox" || item.fieldType === "multipleSelection") && (type = "array"), !formUtil.isEmpty(formRules[k].min) && !formUtil.isEmpty(formRules[k].max) ? (fieldNameRule.min = formRules[k].min, fieldNameRule.max = formRules[k].max, message = item.label + "长度必须大于等于" + formRules[k].min + "并且小于等于" + formRules[k].max) : formUtil.isEmpty(formRules[k].min) ? formUtil.isEmpty(formRules[k].max) || (fieldNameRule.max = formRules[k].max, message = item.label + "长度必须小于等于" + formRules[k].max) : (fieldNameRule.min = formRules[k].min, message = item.label + "长度必须大于等于" + formRules[k].min), formUtil.isEmpty(formRules[k].message) || (message = formRules[k].message), fieldNameRule.message = message, formUtil.isEmpty(type) || (fieldNameRule.type = type), item.fieldType == "select" || item.fieldType == "multipleSelection" || item.fieldType == "radio" || item.fieldType == "checkbox" || item.fieldType == "date" || item.fieldType == "datetime", fieldNameRule.trigger = trigger, fieldNameRules.push(fieldNameRule);
        }
        rules[item.fieldName] = fieldNameRules;
      } catch (t) {
        console.error("规则解析错误：" + t), rules[item.fieldName] = [];
      }
  }
  return reactive(rules);
}
function initFormData(t, e) {
  let a = {};
  for (let l in t) {
    let m = t[l];
    if (m.fieldType === "empty")
      continue;
    let r = m.value;
    if (e && typeof e[m.fieldName] < "u" && (r = e[m.fieldName]), m.isI18n) {
      a[m.fieldName + "_I18n"] = r;
      try {
        r = JSON.parse(r)[store.getters.i18n];
      } catch {
      }
    }
    r = converFormValueByFieldName(m, r, e), a[m.fieldName] = r;
  }
  return reactive(a);
}
export {
  changeState,
  getFormItems,
  initEvent,
  initFormData,
  initOption,
  initRule,
  initState,
  initTableData
};
